/****************************************************************
*Fichier cree par :                                             *
*                 Selma Abdelrahim                              *
*                 Farzana Chutkai                               *
*                 Denis Berthod                                 *
*Pour le projet du cours de systeme du premier semestre         *
*de l'anne 2003/2004 : Le systeme IFS                          *
*****************************************************************/

#include <stdlib.h>

#include "lendian.h"
#include "ifs_types.h"
#include "ifs_tables.h"
#include "ifs_error.h"
/*fonction inserant un nouveau bloc libre dans l'espace des bloc libre*/

int new_free_bloc(USHORT disc_num,USHORT bloc_num){
  USHORT debut;//adresse du bloc
  disc *disque;
  free_bloc f_bloc;
  
  /*recuperation du disque et de la valeu de debut*/
  disque=&disc_table[disc_num];
  debut=disque->free_data_addr;
  /*recuperation du bloc libre*/
  if(read_free_bloc(disc_num,&f_bloc,debut)==-1) return -1;
  /*y a t'il encore de a place?*/
  if(f_bloc.cpt<62){//si oui on insere le bloc dans le tableau
    f_bloc.blocs[f_bloc.cpt]=bloc_num;
    f_bloc.cpt++;
    //printf("new free bloc: il encore de la place\n");
    if(write_free_bloc(disc_num,&f_bloc,debut)==-1)return -1;
  }else{
    /*sinon on cre un nouveau bloc index avec e lien du debut pointant sur lui et le suivant 
     *etant l'ancien premier bloc
     */
    f_bloc.cpt=0;
    f_bloc.next_index=debut;
    disque->free_data_addr=bloc_num;
    //printf("new free bloc :il n'y aplus de place\n");
    if(write_free_bloc(disc_num,&f_bloc,bloc_num)==-1) return -1;
  }
  disque->free_data_space++;
  return 1;
}

/*fonction d'initalisation de l'espace vide d'un disque*/
int init_free_space(USHORT disc_num){
  USHORT cur_bloc;
  free_bloc f_bloc;
  disc *disque;
  /*recuperation dela tructure de disque*/
  disque=&disc_table[disc_num];
  cur_bloc=disque->last_addr;//initialisation au dernier bloc
  /*creation du premier bloc, ce bloc ne compte pas dans l'espace libre car il ne faut l'enlever
  *si l'on veut pouvoir rajouter de des bloc libre dans la structure
  */
  f_bloc.cpt=0;
  f_bloc.next_index=IFS_NULL;
  disque->free_data_addr=cur_bloc;
  if(write_free_bloc(disc_num,&f_bloc,cur_bloc)==-1) return -1;
  disque->free_data_space=0;

  cur_bloc --;
  /*on boucle sur tous les blocs de donnees pour creer la structure*/
  while(cur_bloc >= disque->inode_addr+disque->node_size){
    //printf("free_space_init : le bloc courant est %d\n, l'adresse du bloc index est %d \n",cur_bloc,disque->free_data_addr);//debug
    if(new_free_bloc(disc_num,cur_bloc)==-1)return -1;
    cur_bloc--;
  }
  return 1;
}

/*fonction de recuperation de l'addresse d'un bloc libre*/

USHORT next_bloc(USHORT disc_num){
  disc *disque;
  free_bloc f_bloc;
  USHORT debut,resultat;//adrese dupremier bloc libre

  /*chargement de la structure de disque*/
  disque=&disc_table[disc_num];
  debut=disque->free_data_addr;
  /*verification de l'espace disque restant*/
  if(disque->free_data_space <= 0){
    ifs_err=NO_MORE_SPACE;
    return IFS_NULL;
  }

  /*lecture du premier bloc libre*/
  if(read_free_bloc(disc_num,&f_bloc,debut)==-1) return IFS_NULL;

  if(f_bloc.cpt != 0){
    /*si il y a des bloc dans le tableau alors prendre e premier qui vient*/
    f_bloc.cpt --;
    disque->free_data_space--;
    if(write_free_bloc(disc_num,&f_bloc,debut)==-1)return IFS_NULL;
    resultat= f_bloc.blocs[f_bloc.cpt];
  }else{
    /*si le compteur est a zero alors le bloc alloue est le bloc d'index et on change le pointeur du
     *premier bloc vers le suivant*/
    resultat=debut;
    disque->free_data_addr=f_bloc.next_index;
    disque->free_data_space--;
  }
  return resultat;
}
