/****************************************************************
*Fichier cree par :                                             *
*                 Selma Abdelrahim                              *
*                 Farzana Chutkai                               *
*                 Denis Berthod                                 *
*Pour le projet du cours de systeme du premier semestre         *
*de l'anne 2003/2004 : Le systeme IFS                          *
*****************************************************************/

#ifndef IFS_API
#define IFS_API

#include "ifs_types.h"


/************************** fonctions ifs sur les repertoires **********************/
entree_repertoire dir_entr;

/*ouverture*/
desc_t ifs_opendir(char *reference);

/*lecture des entres*/
entreerep_p ifs_readdir(desc_t descripteur);

/*fermeture*/
int ifs_closedir(desc_t descripteur);

/*creation*/
int ifs_mkdir(char *reference);

/*effacement*/
int ifs_rmdir(char *reference);

/*affichage d repertoire courant*/
int ifs_pwd();//pas encore implment

/*change le repertoire courant*/
int ifs_chdir(char *ref);


/****************************************fonctions de gestion des disques**********************/
/*chagement du disque courant*/
int ifs_chdisc(char *reference);

/*chagement du disque courant en passant son numero*/
int ifs_chdisc_num(int disc_num);

/*renvoie le numero du disc courant*/
int curdisc_num();


/**************************************fonction de consultation des inodes***************************/
/*consultation de l'inode par le nom*/
int ifs_stat(char *reference, stat_p buf);

/*consultation de l'inode par un descripteur*/
int ifs_fstat(desc_t descripteur, stat_p buf);

/**************************************fonction de gestion des liens vers les icones****************/
/*lier un fichier a une icone*/
int ifs_linkicone(char *reference,char *icone);

/*supprimer la liaison entre une icone et un fichier*/
int ifs_unlinkicone(char *reference);

/************************************fonctions de gestion des fichiers***************************/

/*ouverture d'un fichier*/
desc_t ifs_open(char *reference,int mode,int type);

/*ouverture d'un noeud d'icone*/
desc_t ifs_open_iconode(int node_num,int mode);

/*fermeture d'un fichier*/
int ifs_close(desc_t descripteur);

/*liaison physique d'un fichier*/
int ifs_link(char *src,char *dst);

/*supression d'une liaison phsique d'n fichier et suppression du fichier le cas echeant*/
int ifs_unlink(char *src);

/*ecriture dans un fichier*/
int ifs_write(desc_t descripteur,void *tampon,int taille);

/*lecture dans un fichier*/
int ifs_read(desc_t descripteur,void *tampon,int taille);

/*changement de la position de lecture ou d'criture dans le fichier*/
int ifs_seek(desc_t descripteur,pos_t position, int mode);

#endif
