/****************************************************************
*Fichier cree par :                                             *
*                 Selma Abdelrahim                              *
*                 Farzana Chutkai                               *
*                 Denis Berthod                                 *
*Pour le projet du cours de systeme du premier semestre         *
*de l'anne 2003/2004 : Le systeme IFS                          *
*****************************************************************/

#include "ifs_api.h"
#include "ifs_types.h"
#include "ifs_file_util.h"//pour M_LEC
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>//pour STDOUT_FILENO

//fonction de copie d'un fichier sur la sortie standard

void ifs_cat_file(desc_t descripteur){
  char buffer[200];
  int carlu;
  for( ; ; ){
    if((carlu=ifs_read(descripteur,buffer,200))==-1){//lecture d'un fichier ifs
      ifs_fatal_error("ifs_read");
    }
    if(carlu==0) break;//fin du fichier atteinte
    if(write(STDOUT_FILENO,buffer,carlu)!=carlu){//ecriture sur la sortie standard POSIX
      ifs_fatal_error("write");
    }
  }
}

void usage(){
  fprintf(stderr,"usage : ifs_cat <ref1> [<ref2> ...]\n");
  exit(EXIT_FAILURE);
}

int main(int argc, char *argv[]){
  desc_t descripteur;
  int i;
  //struct stat_p buf;//il est prfrable de dclar un ifs_stat qui sera dja allou en mmoire
  ifsstat buf;
  
  
  if(argc==1){
    //ifs_cat_file();//Il est plus simmple de provoqu une erreur ici comme nousn'avons pas de fichier d'entre standard
    usage();
  }else{
    for(i=1;i<argc;i++){
      //verification de l'autorisation du droit de lecture//il n'y a pas de droits en lecture dasn le systme ifs
      //if(acces(argv[i],M_LEC)!=0){
      //fprintf(stderr,"permission denied\n");
      //}else{
      if((descripteur=ifs_open(argv[i],M_LEC,N_ORD))==-1) ifs_fatal_error("ifs_open");
      if(ifs_fstat(descripteur,&buf)==-1){
	ifs_fatal_error("ifs_fstat");
      }
      //verifier si le fichier est de type ORDINAIRE
      if(buf.type!=ORDINAIRE){
	fprintf(stderr,"%s n'est pas un fichier regulier\n",argv[i]);
      }else{
	ifs_cat_file(descripteur);
	if(ifs_close(descripteur)==-1) ifs_fatal_error("ifs_close");
      }
      //}
    }
  }
  
  exit(EXIT_SUCCESS);
}

