/****************************************************************
*Fichier cree par :                                             *
*                 Selma Abdelrahim                              *
*                 Farzana Chutkai                               *
*                 Denis Berthod                                 *
*Pour le projet du cours de systeme du premier semestre         *
*de l'anne 2003/2004 : Le systeme IFS                          *
*****************************************************************/

#include "ifs_api.h"
#include "ifs_file_util.h"
#include <stdio.h>
#include <stdlib.h>

void usage(){
  fprintf(stderr,"Usage : ifs_cp <ref_src> <ref_dst>");
  exit(EXIT_FAILURE);
}

int main(int argc,char *argv[]){
  char buffer[200];
  int d1,d2,nb_lu,type;
  ifsstat info;

  if(argc != 3) usage();

  if((d1=ifs_open(argv[1],M_LEC,N_ORD))==-1) ifs_fatal_error("open1");
  /*determination du type*/
  if(ifs_fstat(d1,&info)==-1) ifs_fatal_error("ifs_fstat");
  switch(info.type){
  case ORDINAIRE:type=N_ORD;break;
  case ICONE:type=N_ICO;break;
  default :fprintf(stderr,"le fichier doit tre un ficher ordinaire ou icone\n");
    exit(EXIT_FAILURE);
  }
  if((d2=ifs_open(argv[2],M_ECR|M_ZER|M_CRE,type))==-1) ifs_fatal_error("open2");
  do{
    if((nb_lu=ifs_read(d1,&buffer,200))==-1) ifs_fatal_error("ifs_read");
    if((ifs_write(d2,&buffer,nb_lu))!=nb_lu) ifs_fatal_error("ifs_write");
  }while(nb_lu != 0);
  if(ifs_close(d1)==-1) ifs_fatal_error("close1");
  if(ifs_close(d2)==-1) ifs_fatal_error("close2");
  exit(EXIT_SUCCESS);
}
