/****************************************************************
*Fichier cree par :                                             *
*                 Selma Abdelrahim                              *
*                 Farzana Chutkai                               *
*                 Denis Berthod                                 *
*Pour le projet du cours de systeme du premier semestre         *
*de l'anne 2003/2004 : Le systeme IFS                          *
*****************************************************************/

#include "lendian.h"
#include "ifs_types.h"
#include "ifs_error.h"
#include "ifs_ino_util.h"
#include "ifs_dir_util.h"
#include "ifs_tables.h"
#include "ifs_kernelio.h"
#include "ifs_disc_util.h"
#include <stdlib.h>

/*fonction dterminat le numero de bloc logique a partir de l'offset dans un fichier, utilliser avec la taille
 *elle renvoie le nombre de blocs logiques
 */


/*ajout d'une entre dans un repertoire*/
int add_dir_entry(USHORT disc_num,USHORT dir_node_num,char *ent_name,USHORT link_num){
  inode ino,link_ino;
  USHORT new_bloc_addr,new_index_addr;
  bloc_rep b_dir;
  entree_repertoire rep_entr;
  byte_addr b_adresse;
  data_index data_b;
  
  /*test sur la longueur du nom*/
  if(strlen(ent_name)>=30){
    ifs_err=NAME_TOO_LONG;
    return -1;
  }
  /*creation de l'entre du repertoire*/
  strcpy(rep_entr.nom,ent_name);
  rep_entr.numero=link_num;
  //printf("lecture de l'inode\n");//debug
  if (read_ino(disc_num,&ino,dir_node_num)==-1) return -1;
  //printf("l'inode a ete lu,sa taille est %d\n",ino.taille);//debug
  if(ino.taille==0){
    //printf("lataille est 0\n");
    if((new_bloc_addr=next_bloc(disc_num))==IFS_NULL)return -1;
    //printf("\nle bloc alloue est %d\n\n",new_bloc_addr);
    b_dir[0]=rep_entr;
    if(write_bloc_rep(disc_num,&b_dir,new_bloc_addr)==-1) return -1;
    ino.taille++;
    ino.blocs[0]=new_bloc_addr;
  }else{
    /*recuperatin de l'adresse du dernier bloc ecrit*/
    if(offset2addr(disc_num,dir_node_num,ino.taille*32,&b_adresse)==-1)return -1;
    //printf("____l'adresse est index=%d  indice=%d \n",b_adresse.index,b_adresse.indice);
    if(ino.taille % 4 != 0){//si le dernier bloc n'est pas complet
      if(read_bloc_rep(disc_num,&b_dir,b_adresse.bloc_num)==-1)return -1;
      b_dir[ino.taille%4]=rep_entr;
      if(write_bloc_rep(disc_num,&b_dir,b_adresse.bloc_num)==-1)return -1;
      ino.taille++;
      if(ino.taille == 40){//l'inode est plein : creation d'un bloc d'index
	if((new_index_addr=next_bloc(disc_num))==IFS_NULL) return -1;
	//printf("\n le bloc alloue pour l'index  est %d\n",new_index_addr);
	ino.blocs[10]=new_index_addr;

      }else{
	if(ino.taille%63 ==40){//l'index est plein : creation d'un nouvel index
	  if((new_index_addr=next_bloc(disc_num))==IFS_NULL)return -1;
	  if(read_data_index(disc_num,&data_b,b_adresse.index)==-1)return -1;
	  data_b.next=new_index_addr;
	  if(write_data_index(disc_num,&data_b,b_adresse.index)==-1)return -1;
	}
      }
    }else{//si le dernier bloc est complet, on en cree un autre
      if(b_adresse.index ==-1){//le bloc est reference dans l'inode 
	
	if((new_bloc_addr=next_bloc(disc_num))==IFS_NULL)return -1;
	//printf("\n le bloc alloue est %d\n",new_bloc_addr);
	b_dir[0]=rep_entr;
	if(write_bloc_rep(disc_num,&b_dir,new_bloc_addr)==-1) return -1;
	ino.blocs[ino.taille/4]=new_bloc_addr;
	ino.taille++;
      }else{//le bloc est dans un index
	//printf("____________________debug__________taille >=40\n");
	if((new_bloc_addr=next_bloc(disc_num))==IFS_NULL)return -1;
	b_dir[0]=rep_entr;
	if(write_bloc_rep(disc_num,&b_dir,new_bloc_addr)==-1) return -1;
	if(read_data_index(disc_num,&data_b,b_adresse.index)==-1)return -1;
	data_b.blocs[b_adresse.indice]=new_bloc_addr;
	if(write_data_index(disc_num,&data_b,b_adresse.index)==-1)return -1;
	//printf("augmentation de la taille\n");
	ino.taille++;
      }
    }
  }


  if(write_ino(disc_num,ino,dir_node_num)==-1) return -1;
  /*mise a jour du nombre de lien dans la cible*/
  if(read_ino(disc_num,&link_ino,link_num)==-1) return -1;
  link_ino.liens++;
  if(write_ino(disc_num,link_ino,link_num)==-1) return -1;
  //printf("tout a ete ecrit, la taille de l'inodes est maintenant %d\n",ino.taille);
  return 1;

}



/*fonction construisant la racine d'un disque, a appel entre l'initialisation de l'inode map et
*l'initialisation des acces rapides sur les inodes
*/
int make_root(USHORT disc_num){
  bloc map_b;
  inode root;
  //printf("initialisation de l'indice 0 de la map ino\n"); //debug
  /*mise  a zero du bit reprsentant le node 0*/
  if(read_map_bloc(disc_num,map_b,2)==-1)return -1;
  map_b[0]=map_b[0]&127;
  if(write_map_bloc(disc_num,map_b,2)==-1)return -1;
  //printf("creation de l'inode\n");//debug
  /*creation de l'inode*/
  root.etat=NOEUD_UTILISE;
  root.type=1;
  root.taille=0;
  root.icone=0;//a chang par la suite
  root.liens=0;
  if(write_ino(disc_num,root,0)==-1) return -1;
  //printf("inode_ecrit\n");
  /*creation des liens . et ..*/
  if(add_dir_entry(disc_num,0,".",0)==-1) return -1;
  if(add_dir_entry(disc_num,0,"..",0)==-1) return -1;

  return 1;
}

/*fonction construisant un nouveau repertoire*/
int make_dir(USHORT disc_num,USHORT first_node_num,char *ref_name){
  inode dir_node,father_node;
  int ino_addr,i,ico;
  int father_node_num;
  char dir_name[30];
  entree_repertoire dir_entr;

  /*recherche du numero du noeud pere et du numero du repertoire a creer*/
  if((father_node_num=newref2ino(disc_num,ref_name,dir_name))==-1) return -1;


  //printf("entre dans make_dir\n");
  /*test si l'entree existe deja ou non*/
  //printf("le numero du neud pere est %d \n",father_node_num);
  if(read_ino(disc_num,&father_node,father_node_num)==-1) return -1;
  for(i=0;i<father_node.taille;i++){
    if( read_dir_entr(disc_num,&dir_entr,father_node_num,i)==-1) return -1;
    if(strcmp(dir_entr.nom,dir_name)==0){
      ifs_err = DIR_ENTRY_ALREADY_EXISTS;
      return -1;
    }
  }
  //printf("l'entre n'existe pas dans le repertoire\n");
  /*recuperation de l'adresse de l'icone par defaut*/
  if((ico=ref2ino(disc_num,"/repico"))==-1) return -1;
  /*recuperation d'un nouvel inode*/
  if((ino_addr=next_ino(disc_num))==-1)return -1;
  //printf("make_dir : L'adresse de l'inode est %d \n",ino_addr);
  /*creation de la structure d'inode*/
  dir_node.etat=NOEUD_UTILISE;
  dir_node.type=REPERTOIRE;
  dir_node.taille=0;
  dir_node.liens=0;
  dir_node.icone=ico;
  if(write_ino(disc_num,dir_node,ino_addr)==-1) return -1;
  /*creation des liens . et ..*/
  if(add_dir_entry(disc_num,ino_addr,".",ino_addr)==-1) return -1;
  if(add_dir_entry(disc_num,ino_addr,"..",father_node_num)==-1) return -1;
  /*creation d'un liens dans le repertoire pere*/
  if(add_dir_entry(disc_num,father_node_num,dir_name,ino_addr)==-1) return -1;
  return 1;
}

/*fonction affichant les noms des entrees de repertoire  et les inodes associs*/
int aff_rep(USHORT disc_num,USHORT rep_node_num){
  inode ino;
  entree_repertoire dir_entr;
  int i;
  if(read_ino(disc_num,&ino,rep_node_num)==-1) return -1;
 
  //printf("La taille du repertoire est %d\n",ino.taille);

  for(i=0;i<ino.taille;i++){
    if(read_dir_entr(disc_num,&dir_entr,rep_node_num,i)==-1) return -1;
    //printf("%s %d\n",dir_entr.nom,dir_entr.numero);  
  }
  return 1;
}

/*fonction ecrivant une entree de repertoire a la place d'une autre exitant auparavant*/
int write_dir_entr(USHORT disc_num,entree_repertoire *dir_entr,USHORT rep_ino_num,USHORT entr_num){

  byte_addr b_adresse;
  bloc_rep b_rep;


  offset2addr(disc_num,rep_ino_num,entr_num*32,&b_adresse);
  if(read_bloc_rep(disc_num,&b_rep,b_adresse.bloc_num)==-1) return -1;
  memcpy(&b_rep[entr_num%4],dir_entr,sizeof(*dir_entr));
  //printf("write dir entry : ecriture du bloc repertoire\n");
  if(write_bloc_rep(disc_num,&b_rep,b_adresse.bloc_num)==-1) return -1;
  return 1;
}

/*fonction lisant une entree de repertoire */
int read_dir_entr(USHORT disc_num,entree_repertoire *dir_entr,USHORT rep_ino_num,USHORT entr_num){

  byte_addr b_adresse;
  bloc_rep b_rep;


  offset2addr(disc_num,rep_ino_num,entr_num*32,&b_adresse);
  if(read_bloc_rep(disc_num,&b_rep,b_adresse.bloc_num)==-1) return -1;
  memcpy(dir_entr,&b_rep[entr_num%4],sizeof(*dir_entr));

  return 1;
}



/*fonction effacant une entre de repertoire*/
int del_dir_entry(USHORT disc_num,USHORT dir_node_num,char *ent_name){
  int num_last_entry,num_del_entry;
  inode ino;
  entree_repertoire dir_entr;
  byte_addr b_adresse;
  data_index d_index;

  /*recuperationdela structure d'inode*/
  if(read_ino(disc_num,&ino,dir_node_num)==-1) return -1;
  /*recuperation du numero de la derniere entree*/
  num_last_entry=ino.taille-1;

  /*recuperation du numero de l'entree a suprimer*/
  if((num_del_entry=dir_entry_num(disc_num,dir_node_num,ent_name))==-1) return -1;
  /*si necessaire, on remplace l'entree a liminer par la dernire entree*/
  if(num_last_entry != num_del_entry){
    if(read_dir_entr(disc_num,&dir_entr,dir_node_num,num_last_entry)==-1) return -1;
    if(write_dir_entr(disc_num,&dir_entr,dir_node_num,num_del_entry)==-1) return -1;
  }

  /*elimination de la dernire entree*/
  /*si'lentree est en debut de bloc, il faut rendre ce bloc libre ainsi que,ventuellement, le bloc d'index qui le contient*/
  if(num_last_entry%4==0){
    if(offset2addr(disc_num,dir_node_num,num_last_entry*32,&b_adresse)==-1) return -1;
    if(new_free_bloc(disc_num,b_adresse.bloc_num));
    /*si l'entre est la premiere d'un bloc d'index il faut le liberer*/
    if(num_last_entry == 40){//le dernier bloc est maintenant dans l'inode
      if(new_free_bloc(disc_num,b_adresse.index)==-1) return -1;
      ino.blocs[10]=IFS_NULL;
    }else{
      if(num_last_entry%63==40){//le dernier bloc est maintenant dans un autre bloc d'index
	if(new_free_bloc(disc_num,b_adresse.index)==-1) return -1;
	/*recuperation de l'adresse du bloc d'index precedent : par securite, on fait pointe sont champ next sur IFS_NULL*/
	if(offset2addr(disc_num,dir_node_num,(num_last_entry-1)*32,&b_adresse)==-1) return -1;
	if(read_data_index(disc_num,&d_index,b_adresse.index)==-1) return -1;
	d_index.next=IFS_NULL;
	if(write_data_index(disc_num,&d_index,b_adresse.index)==-1) return -1;
      }
    }
  }
  /*diminution de la taille de l'inode*/
  ino.taille--;
  ino.liens--;
  /*ecriture de l'inode*/
  if(write_ino(disc_num,ino,dir_node_num)==-1) return -1;
     
  return 1;
}

/*fonction renvoyant l' adresse d'un entre de repertoire en connaissant son nom, si le nom n'est pas trouver la valeur retournee est -2
*/
int dir_entry_num(USHORT disc_num,USHORT dir_node_num,char *ent_name){
  inode ino;
  entree_repertoire dir_entr;
  int i;
  if(read_ino(disc_num,&ino,dir_node_num)==-1) return -1;

  for(i=0;i<ino.taille;i++){
    if(read_dir_entr(disc_num,&dir_entr,dir_node_num,i)==-1) return -1;
    //printf("%s %d\n",dir_entr.nom,dir_entr.numero);//debug
    if(strcmp(dir_entr.nom,ent_name)==0){
      return i;
    }
  }
  ifs_err=FILE_DO_NOT_EXISTS;
  return -1;
}

/*fonction ouvrant un repertoire a la lecture, elle renvoie un descripteur*/
desc_t open_dir(USHORT disc_num,char *rep_name){
  inode ino;
  int ino_num,i,vnode_indice;
  mem_node vnode;
  int is_already_in_mem=0;
  open_file o_file;

  /*recuperation du nmero d'inode*/
 if((ino_num=ref2ino(disc_num,rep_name))==-1) return -1;

  /*regarder si l'inode du repertoire n'est pas deja en memoire*/
  for(vnode_indice=0;vnode_indice<MAX_NODE;vnode_indice++){
    vnode=inode_table[vnode_indice];
    if((vnode.inode_num == ino_num)&&(vnode.disc_num==disc_num)&&(vnode.open_cpt!=0)){
      is_already_in_mem =1;
      break;
    }
  }
 

  if(!is_already_in_mem){
    /*recuperation de la structure d'inode*/
    if(read_ino(disc_num,&ino,ino_num)==-1) return -1;
    /*chargement de la structure d'inode dans la table des noeud en memoire*/
    vnode.open_cpt=0;
    vnode.disc_num=disc_num;
    //printf("open_dir : le numero du disc est %d\n",vnode.disc_num);
    vnode.inode_num=ino_num;
    vnode.node=ino;
    for(vnode_indice=0;vnode_indice<MAX_NODE;vnode_indice++){
      if(inode_table[vnode_indice].open_cpt==0){
	inode_table[vnode_indice]=vnode;
	break;
      }
    }
    if(vnode_indice == MAX_NODE){
      ifs_err=TOO_MANY_INODE_IN_MEM;
      return -1;
    } 
  }
  
  /*creation d'une reference dans la table des fichier ouverts*/
  o_file.free=0;
  o_file.mode=0;
  o_file.offset=0;
  o_file.mem_node_num=vnode_indice;

  for(i=0;i<MAX_OPEN;i++){
    if(IS_OPEN_FREE(&o_file_table[i])){
      o_file_table[i]=o_file;
      break;
    }
  }
  if(i == MAX_OPEN){
    ifs_err=TOO_MANY_OPEN_FILES;
    return -1;
  } 
  inode_table[o_file_table[i].mem_node_num].open_cpt++;
  /*retourne l'indice dans la table des fichiers ouverts*/ 
  //printf("le descripteur retourne est %d il pointe vers linode en memoire n%d\n",i,o_file_table[i].mem_node_num);
  return i;
}

/*fermeture d'un repertoire*/
int close_dir(desc_t ifs_descr){
  mem_node *m_ino;
  //printf("close dir le numero du blocinode en memoir pointe est %d\n",o_file_table[ifs_descr].mem_node_num);
  m_ino= &inode_table[o_file_table[ifs_descr].mem_node_num];
  /*decrementation du nombre de fichier ouvert sur ce noeud*/
  m_ino->open_cpt--;
  /*supression de l'entre dans la table des fichier ouverts*/
  o_file_table[ifs_descr].free=1;
  /*ecriture de l'inode dans la table des caches*/
  //printf("closedir : numero du disc= %d,numero_inode =%d\n",m_ino->disc_num,m_ino->inode_num);
  if(write_ino(m_ino->disc_num,m_ino->node,m_ino->inode_num)==-1) return -1;
  return 1;
}


/*leture d'une entree de repertoire*/
int read_dir(desc_t ifs_descr,entree_repertoire *dir_entr){
  mem_node *m_ino;

  m_ino=&inode_table[o_file_table[ifs_descr].mem_node_num];
  if(o_file_table[ifs_descr].offset >= m_ino->node.taille){
    dir_entr =NULL;
    return -1;
  }else{
    if(read_dir_entr(m_ino->disc_num,dir_entr,m_ino->inode_num,o_file_table[ifs_descr].offset)==-1) return -1;
    o_file_table[ifs_descr].offset++;
  }
  return 1;
}

/*suppression d'un repertoire*/
int del_dir(USHORT disc_num,USHORT first_node_num,char *dir_name){
  inode father_node,ino;
  int ino_num,i,father_node_num;
  char entr_name[30], *father_name,path_name[512]; 

  /*recuperation de l'inode du repertoire*/
  if((ino_num=ref2ino(disc_num,dir_name))==-1) return -1;
  if(read_ino(disc_num,&ino,ino_num)==-1) return -1;
  /*recuperation du numero d'inode du pere*/
  father_name=(char *)concat(dir_name,"/..");
  //printf("le nom dupere est %s\n",father_name);
  if((father_node_num=ref2ino(disc_num,father_name))==-1) return -1;

  /*verification que le repertoire est bien vide*/
  if(ino.taille != 2){
    ifs_err=DIR_NOT_EMPTY;
    return -1;
  }

  /*verification que l'inode du repertoire n'est pas ouvert*/
  for(i=0;i<MAX_NODE;i++){
    if((disc_num==inode_table[i].disc_num) && (ino_num==inode_table[i].inode_num) 
       && (inode_table[i].open_cpt != 0)){
      ifs_err=OPEN_DIR;
      return -1;
    }
  }
 
  cutref(dir_name,entr_name,path_name);
  //printf("del dir : la refference a suprime est %s\n",entr_name);

  /*supression du liens dans le repertoire pre*/
  if(del_dir_entry(disc_num,father_node_num,entr_name)==-1) return -1;

  /*liberation de l'inode*/
  if(new_free_node(disc_num,ino_num)==-1) return -1;

  return 1;

}

/***********************fonctions pour le serveur************************/
/*ouverture d'un repertoire*/
void odir(requete *query, reponse *rep){
  if((rep->msg_int=open_dir(cur_disc,query->args))==-1){
    rep->err=-1;
  }else{
    rep->err=0;
  }
}

/*lecture d'une entree de repertoire*/
void rdir(requete *query, reponse *rep){
  entree_repertoire dir_entr;
  if(read_dir(query->args_int,&dir_entr)==-1){
    rep->err=-1;
    return;
  }
  if(&dir_entr==NULL){
    rep->err=-1;
    return;
  }
  strcpy(rep->msg,dir_entr.nom);
  rep->msg_num[0]=dir_entr.numero;
  rep->err=0; 
}


/*fermeture du repertoire*/
void cdir(requete *query, reponse *rep){
  if(close_dir(query->args_int)==-1){
    rep->err=-1;
  }else{
    rep->err=0;
  }
}


/*creation d'un repertoire*/
void mdir(requete *query,reponse *rep){
  //printf("entre dans mdir,ledisque courant est %d et le repertoire courant est %d le repertoire a creer est %s\n"
  //	 ,cur_disc,disc_table[cur_disc].cur_dir,query->args);
  if(make_dir(cur_disc,disc_table[cur_disc].cur_dir,query->args)==-1){
    rep->err=-1;
  }else{
    rep->err=0;
  }
}

/*changement du repertoire courant du disque courant*/
void ch_dir(requete *query,reponse *rep){
  int new_num;
  inode ino;
  printf("le disque courant est %d et le repertoire est %s\n",cur_disc,query->args);
  if((new_num=ref2ino(cur_disc,query->args))==-1){
    rep->err=-1;
    return;
  }
  printf("le nouveau numero est %d\n",new_num);
  /*verification que le neud est bien un repertoire*/
  if(read_ino(cur_disc,&ino,new_num)==-1){
    rep->err=-1;
    return;
  }
  //printf("fin de la lecture de l'inode pour le test\n");
  if(!IS_REP(&ino)){
    ifs_err= NOT_A_DIR;
    rep->err=-1;
    return;
  }
  //printf("verification que le noeud est u repertoire terminee\n");
  disc_table[cur_disc].cur_dir=new_num;
  rep->err=0;
}

/*supression d'un repertoire*/
void rm_dir(requete *query,reponse *rep){
  if(del_dir(cur_disc,disc_table[cur_disc].cur_dir,query->args)==-1){
    rep->err=-1;
  }else{
    rep->err=0;
  }
}
