/****************************************************************
*Fichier cree par :                                             *
*                 Selma Abdelrahim                              *
*                 Farzana Chutkai                               *
*                 Denis Berthod                                 *
*Pour le projet du cours de systeme du premier semestre         *
*de l'anne 2003/2004 : Le systeme IFS                          *
*****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <string.h>
#include <dirent.h>


#include "ifs_error.h"
#include "ifs_util.h"
#include "ifs_types.h"
#include "ifs_disc_util.h"
#include "ifs_tables.h"
#include "ifs_kernelio.h"


//verification si le disque est ide ou non
int is_empty(disc disque){
  return disque.empty;
}

//initialisation de la table des disques
void init_disc_table(){
  disc disc_vide;
  int i;
  disc_vide.empty=1;
  nb_disc=0;
  for(i=0;i<MAX_DEV;i++) disc_table[i]=disc_vide;
}

//recherche des disques du systeme dans un repertoire donn

int is_ifs_disc(char *file_name){
  int descr;
  LEINT magic;

  if((descr=open(file_name,O_RDONLY)) == -1) fatal_error("open is_ifs_disc");
  if(read(descr,&magic,ISIZE)==-1) fatal_error("read is_ifs_disc");
  if(close(descr)==-1) fatal_error("close is_ifs_disc");
  return (toUINT(magic) == MAGIC);
}

int fput_disc(char *disc_name){
  int descr;
  static disc disque;
  USHORT disc_num;

  if(nb_disc >= MAX_DEV){
    ifs_err = TOO_MANY_DEV;
    return -1;
  }
  if((descr=open(disc_name,O_RDWR))==-1) fatal_error("open put_disc");
  if(read_disc(descr,&disque)==-1) ifs_fatal_error("read_disc put_disc");
  disc_num = disque.dev_num;
  while(!is_empty(disc_table[disc_num])) disc_num++;
  if(disque.dev_num != disc_num){
    disque.dev_num=disc_num;
    if(write_disc(descr,&disque)==-1) ifs_fatal_error("write_disc put_disc");
  }
  disque.empty=0;
  disque.cur_dir=0;//le repertoire courant est la racine
  disc_table[disc_num]=disque;
  nb_disc++;
  printf("\n___________________________________________________________________\n");
  printf("Le disque %s est associe a l'indice %d de la table des disques.\n", 
	 disc_table[disc_num].name,disc_table[disc_num].dev_num);
  printf("Nombre de fichiers utiliss : %d/%d\n",disc_table[disc_num].node_size*4-disc_table[disc_num].free_inode_space,disc_table[disc_num].node_size*4);
  printf("Nombre de blocs utiliss :%d/%d\n",disc_table[disc_num].data_size-disc_table[disc_num].free_data_space,disc_table[disc_num].data_size);
 printf("___________________________________________________________________\n\n");
  if(close(descr)==-1)fatal_error("close put_disc");
}

void disc_search(char *dir){
  DIR *d;
  struct dirent *de;
  struct stat info;
  int flag=0;

  if((d=opendir(dir))==NULL) fatal_error("opendir");
  while ((de=readdir(d))!=NULL){
    //printf("%s\n",de->d_name);//debug
    if(stat(de->d_name,&info)==-1) fatal_error("stat");
    if((S_ISREG(info.st_mode)) && (is_ifs_disc(de->d_name))){
      flag=1;
      if(fput_disc(de->d_name)==-1) {
	ifs_perror("disc_search");
	fprintf(stderr,"le disque %s ne sera pas pris en compte par le systeme.\n",de->d_name);
      }
    }
  }
  if(flag == 0) printf("aucun disque n'a ete trouve\n");
  if(closedir(d) == -1) fatal_error("closedir");
}

USHORT hash_func(char * name){
  USHORT result=0;
  int i;
  for(i=0;i<strlen(name);i++){
    result=(result+name[i])%MAX_DEV;
  }
  return result;
}

/*charge un disque dans le system en connaisant sa structure*/

int put_disc(disc disque){
  USHORT disc_num;
  if(nb_disc >= MAX_DEV){
    ifs_err = TOO_MANY_DEV;
    return -1;
  }

  disc_num = disque.dev_num;
  while(!is_empty(disc_table[disc_num])) disc_num++;
  if(disque.dev_num != disc_num){
    disque.dev_num=disc_num;
  }
  disque.empty=0;
  disque.cur_dir=0;//le repertoire courant est la racine
  disc_table[disc_num]=disque;
  nb_disc++;
  cur_disc=disc_num;
  printf("\n___________________________________________________________________\n");
  printf("Le disque %s est associe a l'indice %d de la table des disques.\n", 
	 disc_table[disc_num].name,disc_table[disc_num].dev_num);
  printf("Nombre de fichiers utiliss : %d/%d\n",disc_table[disc_num].node_size*4-disc_table[disc_num].free_inode_space,disc_table[disc_num].node_size*4);
  printf("Nombre de blocs utiliss :%d/%d\n",disc_table[disc_num].data_size-disc_table[disc_num].free_data_space,disc_table[disc_num].data_size);
  printf("___________________________________________________________________\n\n");
  return 1;
}


/*change de disque en le designant par son numero*/
int ch_disc_num(USHORT disc_num){
  if(is_empty(disc_table[disc_num])){
    ifs_err=NO_SUCH_DEV;
    return -1;
  }
  cur_disc=disc_num;
  printf("cur_disc=%d\n",cur_disc);
  //printf("ch_disc_num : Le disque courant est %s d'indice %d.\n",disc_table[cur_disc].name,disc_table[cur_disc].dev_num);
  return disc_num;
}

/*change de disque en le designant par son nom*/
int ch_disc(char *disc_name){
  USHORT disc_num;
  int cpt=0;

  disc_num=hash_func(disc_name);
  while ((cpt<MAX_DEV)&&
	 ((is_empty(disc_table[disc_num]))||
	  (strcmp((char *)disc_table[disc_num].name,disc_name)))){
    disc_num++;
    cpt++;
  }
  if(cpt>=MAX_DEV){
    ifs_err=NO_SUCH_DEV;
    return -1;
  }
  cur_disc=disc_num;
  printf("Le disque courant est %s d'indice %d.\n",disc_table[cur_disc].name,disc_table[cur_disc].dev_num);
  return disc_num;
}

/*calcul du numero du disc a partir de son nom*/
int discname2num(char *disc_name){
  int disc_num;
  int cpt=0;
  disc_num=hash_func(disc_name);
  while ((cpt<MAX_DEV)&&
	 ((is_empty(disc_table[disc_num]))||
	  (strcmp((char *)disc_table[disc_num].name,disc_name)))){
    disc_num++;
    cpt++;
  }
  if(cpt>=MAX_DEV){
    ifs_err=NO_SUCH_DEV;
    return -1;
  }
  return disc_num;
}

/************************version kernel des fonctions**************/
void cdisc(requete *query,reponse *rep){
  if(ch_disc(query->args)==-1){
    rep->err=-1;
  }else{
    rep->err=0;
  }
}

/*changement du disc par son numero*/
void cnumdisc(requete *query,reponse *rep){
 if(ch_disc_num(query->args_int)==-1){
    rep->err=-1;
  }else{
    rep->err=0;
  }
}

/*recuperation du nommero du disc courant*/
void curdisc(requete *query,reponse *rep){
  rep->msg_int=cur_disc;
  rep->err=0;
}
