/****************************************************************
*Fichier cree par :                                             *
*                 Selma Abdelrahim                              *
*                 Farzana Chutkai                               *
*                 Denis Berthod                                 *
*Pour le projet du cours de systeme du premier semestre         *
*de l'anne 2003/2004 : Le systeme IFS                          *
*****************************************************************/

#ifndef FILE_UTIL
#define FILE_UTIL

#include "ifs_types.h"
#include "ifs_kernelio.h"

/*definition des modes d'ouverture*/

#define M_LEC 1
#define M_ECR 2
#define M_EL 3 /*M_EL == M_LEC |M_ECR*/
#define M_CRE 4
#define M_ZER 8

/*definition de macro pour les modes d'ouverture*/
#define IS_LEC(mode) (mode & M_LEC)
#define IS_ECR(mode) (mode & M_ECR)
#define IS_EL(mode) (mode & M_EL)
#define IS_CRE(mode) (mode & M_CRE)
#define IS_ZER(mode) (mode & M_ZER)

/*definition des types lors de la creation  l'ouverture*/
#define N_ORD 0
#define N_ICO 1

/*macro pour les types*/
#define IS_ORDI(type) (type == N_ORD)
#define IS_ICON(type) (type == N_ICO)

/*definiton des position pou seek*/
#define DEBUT 0
#define COURANT 1
#define FIN 2

/*macro pour les positions*/
#define IS_DEB(pos) (pos==DEBUT)
#define IS_CUR(pos) (pos==COURANT)
#define IS_FIN(pos) (pos==FIN)

/*fonction qui cree un fichier*/
int ifs_creat_file(char *ref,int type);

/*fonction qui ouvre un fichier deja creer*/
int ifs_open_file(char *ref,int mode);

/*fonction qui ouvre un noeud deja creer, ne marche qu'avec les fichier icne*/
int ifs_open_iconode(int node_num,int mode);

/*fonction qui ferme un fichier*/
int ifs_close_file(desc_t descripteur);

/*fonction qui efface un fichier*/
int ifs_del_file_content(char *ref);

/*fonction qui ecrit dans un fichier*/
int write_file(desc_t descripteur,void *tampon,int taille);

/*fonction qui lit dansun fichier*/
int read_file(desc_t desripteur,void *tampon,int taille);

/*fonction qui change l'offset du fichier*/
int seek_file(desc_t descripteur,pos_t position,int mode);

/*fonction booleenne renvoyait l'indice dans la table des noeud si le neoud est deja en memoire -1 si il n'y est pas */
int node_in_mem(int disc_num,int node_num);

/************************************fonctions serveur****************************************/

/*ouverture d'un fichier*/
void ofile(requete *query,reponse *rep);

/*fermeture d'un fichier*/
void cfile(requete *query,reponse *rep);

/*lien physique sur un fichier*/
void lnfile(requete *query,reponse *rep);

/*suppression d'un lien physique et du fichier le cas echeant*/
void unlnfile(requete *query, reponse *rep);

/*ecriture dans un fichier*/
void wfile(requete *query,reponse *rep);

/*lecture dans un fichier*/
void rfile(requete *query,reponse *rep);

/*changement de l'offset*/
void sfile(requete *query, reponse *rep);

/*ouverture d'un noeud d'icone*/
void inopen(requete *query, reponse *rep);
#endif
