/****************************************************************
*Fichier cree par :                                             *
*                 Selma Abdelrahim                              *
*                 Farzana Chutkai                               *
*                 Denis Berthod                                 *
*Pour le projet du cours de systeme du premier semestre         *
*de l'anne 2003/2004 : Le systeme IFS                          *
*****************************************************************/

#ifndef IFS_INO_UTIL
#define IFS_INO_UTIL

#include "ifs_types.h"
#include "ifs_kernelio.h"

typedef struct ino_addr{
  USHORT disc_num;
  USHORT bloc_num;
  USHORT indice;
}ino_addr;

/*convertion d'une addresse inode en numero d'inode*/
USHORT to_ino_num(ino_addr *adresse);

/*convertion d'un numero d'inode sur un disque donn en un adresse*/
void to_ino_addr(ino_addr *adresse,disc *disque, USHORT ino_num);

/*rinitialisation de la table des inode en acces rapide d'un disque (lors de la construction d'un disque)*/
int quick_acces_init(int read_d,disc *disque);

/*idem que la prcdente mais par l'intermediare du kernel*/
int quick_acces_refill(USHORT disc_num);

/*creation d'un nouvel inode sur un disque lors de la phase de creation du disque*/
int create_ino_init(int rw_descr,disc *disque,inode *ino,USHORT ino_num);

/*creation d'un nouvel inode sur le disque par l'intermediaire du kernel*/
int create_ino(USHORT disc_num,inode *ino);

/*ecriture d'un node sur le disque*/
int write_ino(USHORT disc_num,inode ino,USHORT ino_num);

/*lecture d'un inode sur un disque*/
int read_ino(USHORT disc_num,inode *ino,USHORT ino_num);

/*syncronisation de la table des inodes en memoire  avec les blocs inode contenu dans les caches*/
int ino_sync();

/*structure definissant l'addresse en mmoire d'un octet particulier du fichier  partir de son offset
 *par rapport au debut du fichier
 */
typedef struct byte_addr{
  int bloc_num;//numero du bloc dans lequel est l'octet
  int index;/*numero du bloc d'indexdans lequel est reference le bloc conteant l'octet, se champ est -1
		*dans le cas ou l'octet est reference dans l'inode*/
  int indice;//indice du bloc contenant l'adresse du bloc de l'octet dans le bloc-index (le premier octet a l'indice 0)
}byte_addr;

/*convertion d'un offset en addresse*/
int offset2addr(USHORT disc_num,USHORT node_num,int offset,byte_addr *adresse);

/*fonction rendant un inode allouable*/
int new_free_node(USHORT disc_num,USHORT node_num);

/*fonction retournant le prochain inode vide et le mettant  occup dans la inode_map et IFS_NULL en cas d'erreur et diminuant le nombre d'inodes libres*/
int  next_ino(USHORT disc_num);

/*convertion d'une reference absolue ou relative en un numero d'inode*/
int ref2ino(USHORT disc_num,char *ref);

/*convertion d'une reference absolue ou relative dont l' un des membre n'a pas ete cree en un numero d'inode du pere et le champs
*new ref contient le nom qui n'existe pas
*/
int newref2ino(USHORT disc_num,char *ref,char *newref);


/**********************************fonctions pour le serveur***********************************/
/*recuperation d'info par le nom*/
void status(requete *query, reponse *rep);

/*recuperationn de l'inode par le descripteur*/
void fstatus(requete *query, reponse *rep);
#endif
