/****************************************************************
*Fichier cree par :                                             *
*                 Selma Abdelrahim                              *
*                 Farzana Chutkai                               *
*                 Denis Berthod                                 *
*Pour le projet du cours de systeme du premier semestre         *
*de l'anne 2003/2004 : Le systeme IFS                          *
*****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <string.h>
#include <dirent.h>
#include <errno.h>

#include "ifs_kernelio.h"
#include "ifs_error.h"
#include "ifs_util.h"
#include "ifs_types.h"
#include "ifs_disc_util.h"
#include "ifs_tables.h"
#include "ifs_ino_util.h"
#include "free_space_man.h"
#include "ifs_file_util.h"

//traitement des requete
void quit(){
  printf("Synchronisation du system...\n");
  ifs_sync();
  printf("Effacement des tubes de communication avec le serveur.\n");
  if(unlink(IFS_IN)==-1)fatal_error("ifs_kernel quit unlink in");
  if(unlink(IFS_OUT)==-1)fatal_error("ifs_kernel quit unlink out");

  printf("Arret du serveur.\n");
  exit(EXIT_SUCCESS); 
}

void test(requete *query,reponse *rep){
  char *reponse="voici ma reponse";
  reponse=concat(reponse,"\n");
  reponse=concat(reponse,query->args);
  strcpy(rep->msg,reponse);
}

void num_ino_data(requete *query,reponse *rep){

  if((query->dev>=MAX_DEV)||(is_empty(disc_table[query->dev]))){
    rep->err=-1;
    ifs_err=NO_SUCH_DEV;
    return;
  }
  rep->msg_num[0]=disc_table[query->dev].inode_addr;
  rep->msg_num[1]=rep->msg_num[0] + disc_table[query->dev].node_size;
  rep->msg_num[2]=disc_table[query->dev].last_addr;
  rep->err=0;
}



void num_dev(requete *query,reponse *rep){
  USHORT i=0;
  char *disc_name = query->args;
  while((i<MAX_DEV)&&((is_empty(disc_table[i])) || 
		      (strncmp(disc_name,(char *)disc_table[i].name,strlen(disc_name))))) i++;
  if(i==MAX_DEV){
    rep->err=-1;
    ifs_err=NO_SUCH_DEV;
    return;
  }
  rep->msg_num[0]=i;
  rep->err=0;
}

void name_dev(requete *query,reponse *rep){
 if((query->dev>=MAX_DEV)||(is_empty(disc_table[query->dev]))){
    rep->err=-1;
    ifs_err=NO_SUCH_DEV;
    return;
  }
 strcpy(rep->msg,(char *)disc_table[query->dev].name);
 rep->err=0;
}

//initialisation du systeme
/*initialisation de la zone des inodes*/

int init_inode_zone(USHORT disc_num){
  int i;
  bloc_inode ino_bloc;
  inode ino;
  disc * disque;

  /*recuperation de la structure de disque*/
  disque=&disc_table[disc_num];
  printf("la taille de la zone de node est %d\n",disque->node_size);
  /*initialisation du bloc d'inode*/ 
  ino.etat=NOEUD_LIBRE;
  for(i=0;i<4;i++){
    ino_bloc[i]=ino;
  }
  for(i=disque->inode_addr;i<disque->node_size+disque->inode_addr;i++){
    printf("init inode a l'indice %d\n",i);
    if(write_inode(disc_num,&ino_bloc,i)==-1) return -1;
  }
  return 1;
}

int init_disc(requete *query,reponse *rep){
  char *dev_name=(char *)malloc(strlen(query->args)*sizeof(char));
  char *nom;
  char fin;
  USHORT nb_file_max,nb_blocs;
  disc disque;
  int d,i,descr,dirico;
  byte_addr b_adresse;//debug
  char dir[11],file[11];
  inode ino;

  strcpy(dev_name,(char *)query->args);
  nb_file_max=query->args_num[0];
  nb_blocs=query->args_num[1];

  /*contrle du ratio nombre de bloc/nombre de fichiers maximum*/
  if(nb_blocs<=2*(nb_file_max/4+1)+nb_file_max/1024+3){
    nb_file_max=(nb_blocs-3-nb_file_max/1024)/2;
  }
  printf("\nle nombre de fichier max est %d et le nombre de blocs est %d\n\n",nb_file_max,nb_blocs);
  

  /*initialisation de la structure du disque*/
  disque.dev_num=hash_func(dev_name);
  printf("le numero du disque est %d \n",disque.dev_num);
  strcpy((char *)disque.name,dev_name);
  printf("le nom du disque est : %s \n",disque.name);
  disque.node_size=nb_file_max/4 + 1;
  disque.description_size=disque.node_size/256 + ((disque.node_size%256 == 0)?0:1) + 2;//un inode map reprsente...
  printf("le nombre de blocs alloues a la zone de description est : %d \n",disque.description_size);//blocs d'inode
  printf("le nombre de blocs alloues a la zone des noeud est : %d \n",disque.node_size);
  disque.data_size=nb_blocs-(disque.node_size+disque.description_size);
  printf("le nombre de blocs alloues a la zone des donnees est : %d \n",disque.data_size);
  disque.last_addr=nb_blocs-1;
  printf("l'adresse du dernier bloc est %d \n",disque.last_addr);
  disque.free_data_addr=0;/*appel d'une fonction d'initialisation*/
  printf("l'adresse du premier bloc libre est %d \n",disque.free_data_addr);
  disque.free_data_space=disque.data_size;
  printf("le nombre de blocs de donnees libre est %d \n",disque.free_data_space);
  disque.inode_addr=disque.description_size;
  printf("l'addresse de la table des  inodes : %d \n", disque.inode_addr);
  disque.free_inode_space=disque.node_size *4;
  printf("le nombre d'inode libre est : %d \n",disque.free_inode_space);

 /*montage du disque dans la table des disques*/
  if(put_disc(disque)==-1) {rep->err=-1;return -1;}

 /*creation du fichier*/
  nom=concat(dev_name,".ifs");
  if((d=open(nom,O_RDWR|O_TRUNC|O_CREAT,S_IWUSR|S_IRUSR|S_IRGRP|S_IROTH))==-1) {rep->err=-1;return -1;}
  if(lseek(d,nb_blocs*128-1,SEEK_SET)==-1)  {rep->err=-1;return -1;}
  fin='a';
  if(write(d,&fin,1)==-1)  {rep->err=-1;return -1;}
  if(write_disc(d,&disque)==-1)  {rep->err=-1;return -1;}
  if(close(d)==-1)  {rep->err=-1;return -1;}

  /*initialisation des ino_map*/
  printf("initialisation des inode map");
  if(init_ino_map(disque.dev_num,disque.free_inode_space)==-1) {rep->err=-1;return -1;}
  printf("inode map initialis\n");
  /*initialisation des inodes*/
  printf("initialisation de la zone des inodes");
  if(init_inode_zone( disque.dev_num)==-1) {rep->err=-1;return -1;}

  /*creation de la structure d'espace libre*/
  printf("creation de l'espace libre du disque\n");
  if(init_free_space(disque.dev_num)==-1) {rep->err=-1;return -1;}

  /*creation de la racine*/
  printf("creation de la racine\n");
  if(make_root(disque.dev_num)==-1) {rep->err=-1;return -1;}

  /*initalisaion des inodes libres*/
  printf("le numero actuel du disque est %d\n",disque.dev_num);
  if(quick_access_refill(disque.dev_num)==-1) {rep->err=-1;return -1;}
  printf("les addresses des inode libres en acces rapides sont : \n");
  for(i=0;i<32;i++) printf("%d ",disc_table[disque.dev_num].quick_inode[i]);
  printf("\n");
  printf("nombre d'inode en acces rapide : %d \n",disc_table[disque.dev_num].quick_inode_cpt);
  printf("l'indice du prochain inode libre est %d \n",disc_table[disque.dev_num].quick_inode_ind);
  /* printf("creation du repertoire d'icones\n");
  if(make_dir(disque.dev_num,0,"Icones")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep1")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep2")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep3")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep4")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep5")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep6")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep7")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep8")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep9")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep10")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep11")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep12")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep13")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep14")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep15")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep16")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep17")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep18")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep19")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep20")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep21")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep22")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep23")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep24")==-1) {rep->err=-1;return -1;}
  printf("\n_______________________creation du repertoire 25\n");
  if(make_dir(disque.dev_num,0,"rep25")==-1) {rep->err=-1;return -1;}
  printf("\n________________________fin creation du repertoire 25\n");
  if(make_dir(disque.dev_num,0,"rep26")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep27")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep28")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep29")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep30")==-1) {rep->err=-1;return -1;}*/
  /*if(make_dir(disque.dev_num,0,"rep31")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep32")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep33")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep34")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep35")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep36")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep37")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep38")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep39")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep40")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep41")==-1) {rep->err=-1;return -1;}
  if(make_dir(disque.dev_num,0,"rep42")==-1) {rep->err=-1;return -1;}*/
  /*if(ifs_creat_file("/icone",N_ICO)==-1){rep->err=-1;return -1;}
  printf("---------------->>>>>>>>fichier /icone creer\n");
  if(ifs_creat_file("/rep1/ord",N_ORD)==-1){rep->err=-1;return -1;}
  printf("contenu du repertoire racine :\n");
  aff_rep(disque.dev_num,0);
  printf("contenu du repertoire icone\n");
  aff_rep(disque.dev_num,39);*/

  printf("creation de l'icone par defaut de reperoire\n");
  strcpy(dir,"<==REP===>");
  if(ifs_creat_file("repico",N_ICO)==-1){rep->err=-1;return -1;}
  if((descr=ifs_open_file("repico",M_ECR))==-1){rep->err=-1;return -1;}
  if(write_file(descr,&dir,11)==-1){rep->err=-1;return -1;}
  if(ifs_close_file(descr)==-1){rep->err=-1;return -1;}

  printf("liasond el'icone avec la racine\n");
  /*recuperation du numero du neoud de l'icone*/
  if((dirico=ref2ino(disque.dev_num,"/repico"))==-1) {rep->err=-1;return -1;}
  /*lecture de la racine*/
  if(read_ino(disque.dev_num,&ino,0)==-1){rep->err=-1;return -1;}
  /*changement du champs icone*/
  ino.icone=dirico;
  /*ecriture de la racine*/
  if(write_ino(disque.dev_num,ino,0)==-1){rep->err=-1;return -1;}

 printf("creation de l'icone par defaut de fichier\n");
  strcpy(dir,"<FICHIER=>");
  if(ifs_creat_file("ficico",N_ICO)==-1){rep->err=-1;return -1;}
  if((descr=ifs_open_file("ficico",M_ECR))==-1){rep->err=-1;return -1;}
  if(write_file(descr,&dir,11)==-1){rep->err=-1;return -1;}
  if(ifs_close_file(descr)==-1){rep->err=-1;return -1;}

  for(i=0;i<32;i++) printf("%d ",disc_table[disque.dev_num].quick_inode[i]);
  printf("\n");
  printf("nombre d'inode en acces rapide : %d \n",disc_table[disque.dev_num].quick_inode_cpt);
  printf("l'indice du prochain inode libre est %d \n",disc_table[disque.dev_num].quick_inode_ind);

  /*if((d=dir_entry_num(disque.dev_num,0,"rep42"))==-1) {rep->err=-1;return -1;}
    printf("l'adresse du reper toire rep42 est entre_num=%d\n",d);*/
  /* printf("effacement de rep20\n");
  if(del_dir(disque.dev_num,0,"rep20")==-1) {rep->err=-1;return -1;}
  printf(" effacement de rep42\n");
  if(del_dir(disque.dev_num,0,"rep42")==-1) {rep->err=-1;return -1;}
  printf("effacement de rep12\n");
 if(del_dir(disque.dev_num,0,"rep12")==-1) {rep->err=-1;return -1;}
  printf("effacement de rep2\n");
 if(del_dir(disque.dev_num,0,"rep2")==-1) {rep->err=-1;return -1;}
  printf("effacement de rep21\n");
 if(del_dir(disque.dev_num,0,"rep21")==-1) {rep->err=-1;return -1;}
  printf("effacement de rep5\n");
  if(del_dir(disque.dev_num,0,"rep5")==-1) {rep->err=-1;return -1;}*/

 printf(" le numero d'inode de Icones/../rep7/./ est %d \n",ref2ino(disque.dev_num,"Icones/../rep7/./"));
  aff_rep(disque.dev_num,0);
  rep->err=0;

 for(i=0;i<32;i++) printf("%d ",disc_table[disque.dev_num].quick_inode[i]);
  printf("\n");
  printf("nombre d'inode en acces rapide : %d \n",disc_table[disque.dev_num].quick_inode_cpt);
  printf("l'indice du prochain inode libre est %d \n",disc_table[disque.dev_num].quick_inode_ind);

  return 0;
 
}

//retourne la cause d'une erreur ifs
void ifscause(reponse *rep){
  rep->msg_int=ifs_err;
}

//retourne la cause d'une erreur ifs
void errcause(reponse *rep){
  rep->msg_int=errno;
}

//initialisatio de la table des caches
void init_cache_table(){
  cache buf;
  int i;

  buf.free=1;
  for(i=0;i<MAX_CACHE;i++){
    cache_table[i]=buf;
  }
}

//initialisation de la table des inodes en memoire
void init_inode_table(){
  mem_node m_node;
  int i;

  m_node.open_cpt=0;
  for(i=0;i<MAX_NODE;i++){
    inode_table[i]=m_node;
  }
}

//initialisation de la table des fichiers ouverts
void init_open_table(){
  open_file o_file;
  int i;

  o_file.free=1;
  for(i=0;i<MAX_OPEN;i++){
    o_file_table[i]=o_file;
  }

}

//syncronisation du systeme avec les donneees sur les disques

int ifs_sync(){
  int i,descr;
  char *nom;

  /*synchronisation de la table des inodes avec les caches*/
  if(ino_sync()==-1)return -1;
  printf("...table des inode en memoire synchronisee...\n");
  /*synchronisation des caches avec les disques*/
  for(i=0;i<MAX_CACHE;i++){
    if(!CACHE_VIDE(&cache_table[i])){
      nom=concat((char *)disc_table[cache_table[i].disc_num].name,".ifs");
      if((descr=open(nom,O_WRONLY))==-1) return -1;
      if(writeb(descr,cache_table[i].bloc,cache_table[i].bloc_num)==-1) return -1;
      if(close(descr)==-1) return -1;
    }
  }
  printf("...table des caches synchronisee...\n");
  /*synchronisation des superblocs*/
  for(i=0;i<MAX_DEV;i++){
    if(!is_empty(disc_table[i])){
      nom=concat((char *)disc_table[i].name,".ifs");
      if((descr=open(nom,O_WRONLY))==-1) return -1;
      if(write_disc(descr,&disc_table[i])==-1) return -1;
      if(close(descr)==-1) return -1;
    }
  }
  printf("...table des disques synchronisee...\n Le systeme est synchronise.\n");
  return 1;
} 

/*fonction verifiant que la dernire cession c'est terminee corectement en regardant dans le repertoir spcifi
si il trouve les tubes qui auraient du etre detruit a la fin d'une session normale*/
void check_system(char *dir){
 DIR *d;
 struct dirent *de;
 int flag = 1;

 if((d=opendir(dir))==NULL) fatal_error("check_system:opendir");
 while(((de=readdir(d)) !=NULL) && (flag)){
   //printf("debuggage\n");
   //printf("%s\n",de->d_name);//debug
   if((strcmp(de->d_name,IFS_OUT)==0) || (strcmp(de->d_name,IFS_OUT)==0)){
     printf("\n\n!!!!! ATTENTION!!!!!!\n");
     printf("!!!!Le systeme c'est termin anormalement lors de la session precedente :\n");
     printf("!!!!L'integrite du systeme est peut etre detruite \n");
     printf("!!!!Tentative de supression des tubes. \n\n\n" );
     unlink(IFS_IN);
     unlink(IFS_OUT);
     flag=0;
   }
 }
 if (flag) printf("La dernire session c'est termine correctement\n");
}

int main(int argc,char *argv[]){
  int descr_in,descr_out,nblu,nbecr,i;
  requete query;
  reponse rep;

  /*initialisation du systeme*/
  printf("Verification de la bonne terminaison de la session precedente\n");
  check_system(".");
  printf("Initialisation de la table des disques.\n\n");
  nb_disc=0;
  init_disc_table();

  printf("initialisation de la table des caches\n");
  init_cache_table();

  printf("Initialisation de la table des noeuds en memoire\n");
  init_inode_table();

  printf("Initialisation de la table des fichiers ouverts\n");
  init_open_table();

  printf("Recherche des disques du systeme.\n");
  disc_search(".");
  printf("\n");

  printf("Recherche du disque courant.\n");
  printf("nb_disc=%d\n",nb_disc);
  if(nb_disc==0){
    printf("Le systeme n'a pas trouve de disques.\n");
  }else{
    i=0;
    while((is_empty(disc_table[i])) && (i<MAX_DEV)){
      i++;
    }
    ch_disc_num(i);
  }
  
  //ch_disc_num(6);//debug
  
  /*server*/
  //cration des tubes pour communiquer
  if(mkfifo(IFS_IN,S_IRUSR|S_IWUSR|S_IWGRP|S_IWOTH)==-1) fatal_error("ifs_kernel : mkfifo ifs_in");
  if(mkfifo(IFS_OUT,S_IWUSR|S_IRUSR|S_IRGRP|S_IROTH)==-1)fatal_error("ifs_kernel : mkfifo ifs_out");
  //printf("les tubes on ete cree\n");
  while(1){
    if((descr_in=open(IFS_IN,O_RDONLY))==-1) fatal_error("ifs_kernel : open in");//bloquant tant que send n'a pas ouvert le tube
    if((nblu=read(descr_in,&query,sizeof(requete)))==-1) fatal_error("ifs_kernel read requete");
    if(close(descr_in)==-1)fatal_error("ifs_kernel quit close");
    //printf("le code de la requete est %d\n",query.code);
    switch(query.code){
    case 0:quit(descr_in);
    case 1:num_ino_data(&query,&rep);break;
    case 2:name_dev(&query,&rep);break;
    case 3:num_dev(&query,&rep);break;
    case 4:init_disc(&query,&rep);break;
    case 5:ifscause(&rep);break;
    case 6:errcause(&rep);break;
    case 7:odir(&query,&rep);break;
    case 8:rdir(&query,&rep);break;
    case 9:cdir(&query,&rep);break;
    case 10:mdir(&query,&rep);break;
    case 11:ch_dir(&query,&rep);break;
    case 12:rm_dir(&query,&rep);break;
    case 13:cdisc(&query,&rep);break;
    case 14:cnumdisc(&query,&rep);break;
    case 15:curdisc(&query,&rep);break;
    case 16:status(&query,&rep);break;
    case 17:fstatus(&query,&rep);break;
    case 18:lnico(&query,&rep);break;
    case 19:ulnico(&query,&rep);break;
    case 20:ofile(&query,&rep);break;
    case 21:cfile(&query,&rep);break;
    case 22:lnfile(&query,&rep);break;
    case 23:unlnfile(&query,&rep);break;
    case 24:wfile(&query,&rep);break;
    case 25:rfile(&query,&rep);break;
    case 26:sfile(&query,&rep);break;
    case 27:inopen(&query,&rep);break;
    default:
      fprintf(stderr,"Le code de la requete n'est pas reconnu\n");
      rep.err=-1;
    }
    if((descr_out=open(IFS_OUT,O_WRONLY))==-1) fatal_error("ifs_kernel : open out");//bloquant tant que receive n'a pas ouvert 
    if((nbecr=write(descr_out,&rep,sizeof(rep)))==-1) fatal_error("ifs_kernel : write rep");
    if(close(descr_out)==-1) fatal_error("ifs_kernel : close out");
  }
}
