/****************************************************************
*Fichier cree par :                                             *
*                 Selma Abdelrahim                              *
*                 Farzana Chutkai                               *
*                 Denis Berthod                                 *
*Pour le projet du cours de systeme du premier semestre         *
*de l'anne 2003/2004 : Le systeme IFS                          *
*****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <string.h>

#include "ifs_util.h"
#include "ifs_error.h"
#include "ifs_kernelio.h"

//envoi de requetes
void send(requete *query){
  int descr_query;
  if((descr_query=open(IFS_IN,O_WRONLY))==-1) fatal_error("ifs_kernel send open query");
  if(write(descr_query,query,sizeof(requete))==-1) fatal_error("ifs_kernel send write query");
  if(close(descr_query)==-1) fatal_error("ifs_kernel send close query");
}

//reception de reponse
void receive(reponse *rep){
  int descr_rep,nblu;
  if((descr_rep=open(IFS_OUT,O_RDONLY))==-1) fatal_error("ifs_kernel receive open rep");
  if((nblu=read(descr_rep,rep,sizeof(reponse)))==-1) fatal_error("ifs_kernel receive read rep");
  if(close(descr_rep)==-1) fatal_error("ifs_kernel receive close rep");
}

//arret du serveur
void ifs_exit(){
  requete query;
  query.code=0;
  send(&query);
}

//test du serveur
void ifs_test(){
  requete query;
  reponse rep;
  query.code=1;
  query.dev=10;
  strcpy(query.args,"123:456:789:456:123");
  send(&query);
  receive(&rep);
  printf("%s\n",rep.msg);
}

//demande de la fourchette num_inode num_data
int ifs_num_ino_data(USHORT num_disque,reponse *rep){
  requete query;
  query.code=NOS_BLOCS_INO_DATA;
  query.dev=num_disque;
  send(& query);
  receive(rep);
  if(rep->err==-1) return -1;
  // printf("les inodes et les donnes  sont dans les fourchettes %d %d %d\n",
  // rep->msg_num[0],rep->msg_num[1],rep->msg_num[2]);//debug
  return 1;
}

//demande le nom d'un disque
int ifs_name_dev(USHORT num_disque,reponse *rep){
  requete query;
  query.code=NAME_DEV;
  query.dev=num_disque;
  send(&query);
  receive(rep);
  if(rep->err==-1) return -1;
  //printf("le nom du disque de numero %d est %s \n",num_disque,rep->msg);//debug
  return 1;
}

//renvoie du numero du disque  partir de son nom

int ifs_num_dev(char *disc_name,reponse *rep){
  requete query;
  query.code=NUM_DEV;
  strcpy(query.args,disc_name);
  send(&query);
  receive(rep);
  if(rep->err==-1) return -1;
  //printf("le numero du disque %s est %d \n",disc_name,rep->msg_num[0]);
  return 1; 
}

//initalistion d'un nouveau disque
int ifs_new_disc(char *disc_name,USHORT nb_file_max,USHORT nb_blocs){
  requete query;
  reponse rep;
  query.code=NEW_DISC;
  strcpy(query.args,disc_name);
  query.args_num[0]=nb_file_max;
  query.args_num[1]=nb_blocs;
  send(&query);
  receive(&rep);
  if(rep.err==-1) return -1;
  printf("le disque %s a ete cree avec succes\n",disc_name);
  return 1;
}

//demande de a cause d'une erreur (valeur de ifs_err)
int ifs_cause(){
 requete query;
 reponse rep;
 query.code=IFS_CAUSE;
 send(&query);
 receive(&rep);
 return rep.msg_int;
}

//demande de a cause d'une erreur (valeur de err_no)
int cause(){
 requete query;
 reponse rep;
 query.code=CAUSE;
 send(&query);
 receive(&rep);
 return rep.msg_int;
}
