/****************************************************************
*Fichier cree par :                                             *
*                 Selma Abdelrahim                              *
*                 Farzana Chutkai                               *
*                 Denis Berthod                                 *
*Pour le projet du cours de systeme du premier semestre         *
*de l'anne 2003/2004 : Le systeme IFS                          *
*****************************************************************/

#ifndef IFS_KERNELIO
#define IFS_KERNELIO

#include "lendian.h"

//noms des tubes de comunication
#define IFS_IN "ifs_in"
#define IFS_OUT "ifs_out"
#define IFS_RW "ifs_rw"

//definitioin de la structure des requtes
typedef struct requete{
  USHORT code;//code de la requete : dtermine les opration  effectuer
  USHORT dev;//no du disque concern par la requete
  USHORT args_num[10];//arguments numriques
  char args[100];//arguments ventuels
  int args_int;//argument entier
}requete;

//definition des codes de requetes
#define QUIT (USHORT)0
#define NOS_BLOCS_INO_DATA (USHORT)1 //demande d'envoi du numero du premier bloc inode et du premier bloc donn 
#define NAME_DEV (USHORT)2//demande du nom d'un dsique
#define NUM_DEV (USHORT)3//demande du numero associe au nom d'un disque
#define NEW_DISC (USHORT)4//creation d'un nouveau disque par makeifs
#define IFS_CAUSE (USHORT)5//demande de la valeur de la variable d'erreur ifs_err
#define CAUSE (USHORT)6//demande de la valeur de la variable d'erreue err_no
#define OPENDIR (USHORT)7//demande de l'ouverture d'un repertoire en lecture
#define READDIR (USHORT)8//demande de lecture d'une entree de repertoire
#define CLOSEDIR (USHORT)9//demande de fermeture d'un repertoire ouvret par ifs_opendir
#define MKDIR (USHORT)10//demande la creation d'un repertoire
#define CHDIR (USHORT)11//changement du repertoire courant
#define RMDIR (USHORT)12//supression d'un repertoire
#define CHDISC (USHORT)13//changement du disc courant
#define CHDISCNUM (USHORT)14//changement du disc courant par son numero
#define CURDISC (USHORT)15//recuperation du numero du disc courant
#define STAT (USHORT)16//fonction de mandant des static sur un nom avec le nom 'ne refrence
#define FSTAT (USHORT)17//fonction recuperant les statistiques a partir d'un descripteur
#define LNICO (USHORT)18//fonction liant une icone a un fichier
#define ULNICO (USHORT)19//fonction deliant l'icone attach a un fichier
#define FOPEN (USHORT)20//fonction d'ouverture d'un fichier
#define FCLOSE (USHORT)21//fermmeture d'un fichier
#define LN (USHORT)22//lien physique
#define UNLN (USHORT)23//suppression d'un liens physique et du fichier s'il n'a plus de liens
#define WR (USHORT)24//eciture dans un fichier
#define RD (USHORT)25//lecture dans un fichier
#define SEEK (USHORT)26//changement de l'offset
#define INOPEN (USHORT)27//ouverture d'un noeud d'icone

//definition de la structure des reponses
typedef struct reponse{
  int err;//diffrent de 0 si il ya eu une erreur lors de l'execution de la requete
  USHORT msg_num[10];//lments numrique de la rponse
  int msg_int;//lement sous forme d'entier de la reponse
  unsigned char msg[100];//lment sus forme d'un chaine de la reponse
}reponse;

//fonction d'envoi de requete
void send(requete *req);

//fonction de reception d'une reponse : rempli l'argument repavec la reponse du serveur
void receive(reponse *rep);

//fonction d'arrt du serveur
void ifs_exit();

//fonction de demande du numero du premier bloc d'inode et de celui de donne et le dernier bloc de donnes
int ifs_num_ino_data(USHORT num_disque,reponse *rep);


//fonction d'ouverture d'un disque en lecture et recuperation du descripteur
int ifs_name_dev(USHORT num_disque, reponse *rep);

//fonction renvoyant le numero d'un disque a partir de son nom
int ifs_num_dev(char *disc_name,reponse *rep);

//fonction renvoyant a valeur de la variable ifs_err
int ifs_cause();

//fonction renvoyant a valeur de la variable err_no
int cause();
 

#endif
