/****************************************************************
*Fichier cree par :                                             *
*                 Selma Abdelrahim                              *
*                 Farzana Chutkai                               *
*                 Denis Berthod                                 *
*Pour le projet du cours de systeme du premier semestre         *
*de l'anne 2003/2004 : Le systeme IFS                          *
*****************************************************************/

#include "ifs_types.h"
#include <stdlib.h>
#include "ifs_api.h"
#include <stdio.h>
#include "ifs_file_util.h"


/*listing des entrees de repertoire*/
int main(int argc,char *argv[]){
  char cur_dir_name[512], cur_disc_name[30],ctype,*entr_name,icone[11];
  int nb_ref,i,disc_num_sauv;
  ifsstat info; 
  desc_t descr,descr_rep;
  entree_repertoire *de;

  disc_num_sauv=curdisc_num();//sauvegarde du n du disc courant
  if(argc == 1){
    nb_ref=1;
    strcpy(cur_dir_name,".");
    *cur_disc_name='\0';
  }else{
    //printf("initialisation ds donnees\n");
    nb_ref=argc-1;
    parse_discref(argv[1],cur_disc_name,cur_dir_name);
    if(*cur_dir_name=='\0') strcpy(cur_dir_name,"/.");
    //printf("le nom du disc est %s et le nom du repertoire est %s\n",cur_disc_name,cur_dir_name);
  }

  for(i=1;i<=nb_ref;i++){
    /*changement du disque*/
    if(*cur_disc_name != '\0'){
	if(ifs_chdisc(cur_disc_name)==-1) ifs_fatal_error("changement de disc\n");
    }else{
      if(ifs_chdisc_num(disc_num_sauv)==-1) ifs_fatal_error("changement de disc \n");
    }
    /*ouverture du repertoire*/
    if((descr_rep=ifs_opendir(cur_dir_name))==-1) ifs_fatal_error("ifs_opendir");
    /*affihage des in du repertoire courant (test por fstat)*/

    /*printf("info repertoire courant (test pour fstat)\n");
     if(ifs_fstat(descr_rep,&info)==-1) ifs_fatal_error("recuperation des donnes du repertoire courant");
     printf("inode   type  liens  icone taille  disc \n");
     printf("----------------------------------------\n");
     ctype='R';
     printf("%5d  %4c %6d %6d %6d %6d\n",info.node_num,ctype,info.liens,info.icone,info.taille,info.disc_num );
     printf("----------------------------------------\n\n");*/
    /*lecture des entrees de repertoires*/
    printf("  icone           nom         inode type  liens  taille  disc \n");
    printf("--------------------------------------------------------------\n");
    while((de=(entree_repertoire *)ifs_readdir(descr_rep)) != NULL){
      /*recuperation des donnes*/
      entr_name=(char *)concat_rep(cur_dir_name,de->nom);
      if(ifs_stat(entr_name,&info)==-1) ifs_fatal_error("recuperation des donnes");
      /*initialisation dela variable ctype*/
      switch(info.type){
      case ORDINAIRE:ctype='O';break;
      case REPERTOIRE:ctype='R';break;
      case ICONE:ctype='I';break;
      default : fprintf(stderr,"Le type du fichier n'est pas reconnu\n");
      }
      /*recherche de l'icone*/
      if((ctype=='I')||(info.icone == 0)){
	strcpy(icone,"**********");
      }else{
	if((descr=ifs_open_iconode(info.icone,M_LEC))==-1) ifs_fatal_error("ifs_open_iconode");
	if(ifs_read(descr,&icone,11)==-1) ifs_fatal_error("read icone");
	if(ifs_close(descr)==-1) ifs_fatal_error("close icone");
      }
      //printf("%5d  %20s %4c %6d %10s %6d %6d\n",de->numero,de->nom,ctype,info.liens,icone,info.taille,info.disc_num );
      printf("%10s   %-15s %5d %4c %6d %6d %6d\n",icone,de->nom,de->numero,ctype,info.liens,info.taille, info.disc_num);
    }
    if(ifs_closedir(descr_rep)==-1) ifs_fatal_error("ifs_closedir");
    /*reinitialisation des noms de discs et repertoires*/
    if(i != nb_ref){
      parse_discref(argv[i+1],cur_disc_name,cur_dir_name);
      if(*cur_dir_name=='\0') strcpy(cur_dir_name,"/");
    } 
  }
  if(ifs_chdisc_num(disc_num_sauv)==-1) ifs_fatal_error("retour au disque d'origine");;
  exit(EXIT_SUCCESS);

}
