/****************************************************************
*Fichier cree par :                                             *
*                 Selma Abdelrahim                              *
*                 Farzana Chutkai                               *
*                 Denis Berthod                                 *
*Pour le projet du cours de systeme du premier semestre         *
*de l'anne 2003/2004 : Le systeme IFS                          *
*****************************************************************/

#ifndef IFS_TABLES
#define IFS_TABLES
 
#include "ifs_types.h"

/*table des disques*/
disc disc_table[MAX_DEV];
int nb_disc;


/*table des inodes en memoire*/

/*structure utilisee pour les entree de la table des inodes en memoire*/
typedef struct mem_node{
  USHORT open_cpt;//nombre d'ouverture
  USHORT disc_num;//numero du disque contenant l'inode
  USHORT inode_num;//numero de l'inode
  inode node;//le noeud concern
}mem_node;

mem_node inode_table[MAX_NODE];

/*table des fichiers ouverts*/
/*structure associee*/
typedef struct open_file{
  int free;//vaut 1 si l'emplacement est libre
  int mode;//mode d'ouverture
  int offset;//position de la tete de lecture ecriture
  USHORT mem_node_num;//pointeur sur une entre de la table des noeud en memoire
}open_file;

#define IS_OPEN_FREE(pof) ((pof)->free==1)

open_file o_file_table[MAX_OPEN];


/*TABLE DES CACHES*/
/*structure pour un cache*/
typedef struct cache{
  int free;//1 si le cache est libre et 0 sinon
  bloc bloc;//bloc de donnee en little-endian
  USHORT disc_num;//numero du disque
  USHORT bloc_num;//mumero du bloc
  int bloc_type;//0:donnee ; 1:inode ; 2:index de donn ; 3:repertoire ; 4:libre ; 5:inode_map

}cache;

#define CACHE_VIDE(pcache) ((pcache)->free == 1)

cache cache_table[MAX_CACHE];

/*fonction de hashage pour la table des caches*/
//int hash_cache(USHORT disc_num,USHORT bloc_num);
#define HASH_CACHE(disc_num,bloc_num) ((disc_num+bloc_num)%MAX_CACHE)

#endif
