/****************************************************************
*Fichier cree par :                                             *
*                 Selma Abdelrahim                              *
*                 Farzana Chutkai                               *
*                 Denis Berthod                                 *
*Pour le projet du cours de systeme du premier semestre         *
*de l'anne 2003/2004 : Le systeme IFS                          *
*****************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <fcntl.h>
#include "ifs_types.h"
#include "blocio.h"
#include"lendian.h"
#include "ifs_error.h"
#include "ifs_kernelio.h"
#include "ifs_tables.h"

//ecriture d'un bloc disque

int write_disc(int descripteur,disc *disque){
  int i;
  LEINT magic;
  LESHORT leus,zero;
  toLESHORT(0,zero);

  //creation du bloc
  bloc bloc_disc;
  //initialisation du bloc
  toLEINT(MAGIC,magic);
  memcpy(bloc_disc+0,magic,ISIZE);

  toLESHORT(disque->dev_num,leus);
  memcpy(bloc_disc+16,leus,SSIZE);

  memcpy(bloc_disc+18,disque->name,32*sizeof(char));

  toLESHORT(disque->description_size,leus);
  memcpy(bloc_disc+4,leus,SSIZE);

  memcpy(bloc_disc+6,zero,SSIZE);

  toLESHORT(disque->node_size,leus);
  memcpy(bloc_disc+8,leus,SSIZE);

  memcpy(bloc_disc+10,zero,SSIZE);


  toLESHORT(disque->data_size,leus);
  memcpy(bloc_disc+12,leus,SSIZE);

  memcpy(bloc_disc+14,zero,SSIZE);

  toLESHORT(disque->last_addr,leus);
  memcpy(bloc_disc+50,leus,SSIZE);

  toLESHORT(disque->free_data_addr,leus);
  memcpy(bloc_disc+52,leus,SSIZE);

  toLESHORT(disque->free_data_space,leus);
  memcpy(bloc_disc+54,leus,SSIZE);

  toLESHORT(disque->inode_addr,leus);
  memcpy(bloc_disc+56,leus,SSIZE);

  toLESHORT(disque->free_inode_space,leus);
  memcpy(bloc_disc+58,leus,SSIZE);

  for(i=0;i<32;i++){
    toLESHORT(disque->quick_inode[i],leus);
    memcpy(bloc_disc+60+(2*i),leus,SSIZE);
  }

  toLESHORT(disque->quick_inode_cpt,leus);
  memcpy(bloc_disc+124,leus,SSIZE);

  toLESHORT(disque->quick_inode_ind,leus);
  memcpy(bloc_disc+126,leus,SSIZE);

  //debut debug
  //affblk(bloc_disc);
  //fin debug

  if(writeb(descripteur,bloc_disc,0)==-1){
    return -1;
  }else{
    return 1;
  }
}

int read_disc(int descripteur,disc *disque){
  int i;
  bloc bloc_disc;
  LESHORT leus;


  /*lecture du bloc*/
  LEINT magic; 
  if(readb(descripteur,bloc_disc,0)==-1){
    return -1;
  }

 /*recup magic number*/
  memcpy(magic,bloc_disc+0,ISIZE);
  if(toUINT(magic) != MAGIC){
    ifs_err=4;
    return -1;
  }

  /*recup num du disque*/
  memcpy(leus,bloc_disc+16,SSIZE);
  disque->dev_num=toUS(leus);

  /*recup nom disque*/
  memcpy(disque->name,bloc_disc+18,sizeof(char)*32);
  
  /*recup taille zone description du disque*/
  memcpy(leus,bloc_disc+4,SSIZE);
  disque->description_size=toUS(leus); 

  /*recup taille zone des noeuds du disque*/
  memcpy(leus,bloc_disc+8,SSIZE);
  disque->node_size=toUS(leus);

  /*recup taille zone de donnnee du disque*/
  memcpy(leus,bloc_disc+12,SSIZE);
  disque->data_size=toUS(leus);

  /*recup addresse du dernier bloc du disque*/
  memcpy(leus,bloc_disc+50,SSIZE);
  disque->last_addr=toUS(leus);

  /*recup addresse du premier bloc de donnee libre du disque*/
  memcpy(leus,bloc_disc+52,SSIZE);
  disque->free_data_addr=toUS(leus);

 /*recup du nombre de  bloc de donnee libre du disque*/
  memcpy(leus,bloc_disc+54,SSIZE);
  disque->free_data_space=toUS(leus);

 /*recup de l'addresse du premier block d'inode map du disque*/
  memcpy(leus,bloc_disc+56,SSIZE);
  disque->inode_addr=toUS(leus);

 /*recup du nombre d'inode libre du disque*/
  memcpy(leus,bloc_disc+58,SSIZE);
  disque->free_inode_space=toUS(leus);

 /*recup du tableau d'inode libre en acces rapide du disque*/
  for(i=0;i<32;i++){
    memcpy(leus,bloc_disc+60+(2*i),SSIZE);
    disque->quick_inode[i]=toUS(leus);
  }

  /*recup du compteur d'inode en acces rapide du disque*/
  memcpy(leus,bloc_disc+124,SSIZE);
  disque->quick_inode_cpt=toUS(leus);

  /*recup de l'indice du prochain inode en acces rapide du disque*/
  memcpy(leus,bloc_disc+126,SSIZE);
  disque->quick_inode_ind=toUS(leus);

  
  return 1;
  
}

//verification de la zone d'ecriture 
//type = 0 : zone de description type=1:zone des inodes ; type =2 : zone des donnes
int verif_zone(USHORT disc_num,USHORT no_bloc, int type){
  USHORT deb_ino, deb_data, fin_data;
  deb_ino=disc_table[disc_num].inode_addr;
  deb_data=disc_table[disc_num].node_size+deb_ino;
  fin_data=disc_table[disc_num].last_addr;
  switch(type){
  case 0:if((no_bloc < 2)&&(no_bloc >= deb_ino)) return -1;break;
  case 1:if((no_bloc < deb_ino)&&(no_bloc >= deb_data)) return -1;break;
  case 2:if((no_bloc < deb_data)&&(no_bloc > fin_data)) return -1;break;
  }
  return 1;
}


//ecriture d'un bloc d'inode

int write_inode(USHORT disc_num,bloc_inode *b_ino,USHORT no_bloc){
  bloc bloc_ino;
  LESHORT leus;
  reponse rep;
  int i,j,descr;
  char *disc_name;

  /*verification de l'emplacement d'ecriture*/
  /*if(ifs_num_ino_data(disc_num,&rep)==-1) return -1;
  if((no_bloc<rep.msg_num[0])||(no_bloc >= rep.msg_num[1])){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
    }*/

  if(verif_zone(disc_num,no_bloc,1)==-1){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
  }

  /*ecriture des champs  etat*/
  for(i=0;i<4;i++){
    toLESHORT((*b_ino)[i].etat,leus);
    memcpy(bloc_ino+(i*32),leus,SSIZE);
  }

  /*ecriture des champs type*/
  for(i=0;i<4;i++){
    toLESHORT((*b_ino)[i].type,leus);
    memcpy(bloc_ino+2+(i*32),leus,SSIZE);
  }

 /*ecriture des champs  taille*/
  for(i=0;i<4;i++){
    toLESHORT((*b_ino)[i].taille,leus);
    memcpy(bloc_ino+4+(i*32),leus,SSIZE);
  }

 /*ecriture des champs  liens*/
  for(i=0;i<4;i++){
    toLESHORT((*b_ino)[i].liens,leus);
    memcpy(bloc_ino+6+(i*32),leus,SSIZE);
  }

 /*ecriture des champs  icone*/
  for(i=0;i<4;i++){
    toLESHORT((*b_ino)[i].icone,leus);
    memcpy(bloc_ino+8+(i*32),leus,SSIZE);
  }

 /*ecriture des champs  blocs*/
  for(j=0;j<11;j++){
    for(i=0;i<4;i++){
      toLESHORT((*b_ino)[i].blocs[j],leus);
      memcpy(bloc_ino+10+(2*j)+(i*32),leus,SSIZE);
    }
  }

  //affblk(bloc_ino);//debug
  /*if(ifs_name_dev(disc_num,&rep)==-1)return -1;
  disc_name=(char *)concat(rep.msg,".ifs");
  if((descr=open(disc_name,O_WRONLY))==-1)return -1;
  if(writeb(descr,bloc_ino,no_bloc)==-1)return -1;
  if(close(descr)==-1) return -1;*/
  if(cache_writeb(disc_num,no_bloc,bloc_ino)==-1) return-1;
  return 1;
}


/*lecture d'un bloc d'inode*/
int read_inode(USHORT disc_num,bloc_inode *b_ino,USHORT no_bloc){
  int descr,i,j;
  char *disc_name;
  bloc bloc_ino;
  LESHORT leus;
  reponse rep;

 /*verification de l'emplacement de lecture*/
  /*if(ifs_num_ino_data(disc_num,&rep)==-1) return -1;
  if((no_bloc<rep.msg_num[0])||(no_bloc >= rep.msg_num[1])){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
    }*/

 if(verif_zone(disc_num,no_bloc,1)==-1){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
  }

  /*lecture sur le disque*/
  /*if(ifs_name_dev(disc_num,&rep)==-1)return -1;
  disc_name=(char *)concat(rep.msg,".ifs");
  if((descr=open(disc_name,O_RDONLY))==-1)return -1;
  if(readb(descr,bloc_ino,no_bloc)==-1)return -1;
  if(close(descr)==-1) return -1;*/
  if(cache_readb(disc_num,no_bloc,bloc_ino)==-1) return-1;
  //affblk(bloc_ino);//debug
  /*lecture des champs etat*/
  for(i=0;i<4;i++){
    memcpy(leus,bloc_ino+(i*32),SSIZE);
    (*b_ino)[i].etat=toUS(leus);
  }
  /*lecture des champs type*/
  for(i=0;i<4;i++){
    memcpy(leus,bloc_ino+2+(i*32),SSIZE);
    (*b_ino)[i].type=toUS(leus);
  }
 /*lecture des champs taille*/
  for(i=0;i<4;i++){
    memcpy(leus,bloc_ino+4+(i*32),SSIZE);
    (*b_ino)[i].taille=toUS(leus);
  }
 /*lecture des champs liens*/
  for(i=0;i<4;i++){
    memcpy(leus,bloc_ino+6+(i*32),SSIZE);
    (*b_ino)[i].liens=toUS(leus);
  }
 /*lecture des champs icone*/
  for(i=0;i<4;i++){
    memcpy(leus,bloc_ino+8+(i*32),SSIZE);
    (*b_ino)[i].icone=toUS(leus);
  }
 /*lecture des champs blocs*/
  for(j=0;j<11;j++){
    for(i=0;i<4;i++){
      memcpy(leus,bloc_ino+10+(2*j)+(i*32),SSIZE);
      (*b_ino)[i].blocs[j]=toUS(leus);
    }
  }
  return 1;
}


//ecriture d'un bloc d'index de donne

int write_data_index(USHORT disc_num,data_index *d_index,USHORT no_bloc){
  bloc bloc_ind;
  LESHORT leus;
  reponse rep;
  int i,j,descr;
  char *disc_name;

  /*verification de l'emplacement d'ecriture*/
  /*if(ifs_num_ino_data(disc_num,&rep)==-1) return -1;
  if((no_bloc<rep.msg_num[1])||(no_bloc > rep.msg_num[2])){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
    }*/

 if(verif_zone(disc_num,no_bloc,2)==-1){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
  }

  /*ecriture du champs blocs*/
  for(i=0;i<63;i++){
    toLESHORT(d_index->blocs[i],leus);
    memcpy(bloc_ind+(i*2),leus,SSIZE);
  }

  /*ecriture du champ next*/
    toLESHORT(d_index->next,leus);
    memcpy(bloc_ind+126,leus,SSIZE);

    // affblk(bloc_ind);//debug

  /*ecriture du bloc sur le disque*/
  /*if(ifs_name_dev(disc_num,&rep)==-1)return -1;
  disc_name=(char *)concat(rep.msg,".ifs");
  if((descr=open(disc_name,O_WRONLY))==-1)return -1;
  if(writeb(descr,bloc_ind,no_bloc)==-1)return -1;
  if(close(descr)==-1) return -1;*/
  if(cache_writeb(disc_num,no_bloc,bloc_ind)==-1) return-1;
  return 1;
}


/*lecture d'un bloc d'index de donnes*/
int read_data_index(USHORT disc_num,data_index *d_index,USHORT no_bloc){
  int descr,i,j;
  char *disc_name;
  bloc bloc_ind;
  LESHORT leus;
  reponse rep;

 /*verification de l'emplacement de lecture*/
  /*if(ifs_num_ino_data(disc_num,&rep)==-1) return -1;
  if((no_bloc<rep.msg_num[1])||(no_bloc > rep.msg_num[2])){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
    }*/

 if(verif_zone(disc_num,no_bloc,2)==-1){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
  }

  /*lecture sur le disque*/
  /*if(ifs_name_dev(disc_num,&rep)==-1)return -1;
  disc_name=(char *)concat(rep.msg,".ifs");
  if((descr=open(disc_name,O_RDONLY))==-1)return -1;
  if(readb(descr,bloc_ind,no_bloc)==-1)return -1;
  if(close(descr)==-1) return -1;*/
  if(cache_readb(disc_num,no_bloc,bloc_ind)==-1) return-1;

  /*lecture du champs blocs*/
  for(i=0;i<63;i++){
    memcpy(leus,bloc_ind+(i*2),SSIZE);
    d_index->blocs[i]=toUS(leus);
  }

  /*lecture du champs next*/
    memcpy(leus,bloc_ind+126,SSIZE);
    d_index->next=toUS(leus);
 
  return 1;
}

//ecriture d'un bloc de repertoire

int write_bloc_rep(USHORT disc_num,bloc_rep *b_rep,USHORT no_bloc){
  bloc bloc_rep;
  LESHORT leus;
  reponse rep;
  int i,j,descr;
  char *disc_name;

  /*verification de l'emplacement d'ecriture*/
  /*if(ifs_num_ino_data(disc_num,&rep)==-1) return -1;
  if((no_bloc<rep.msg_num[1])||(no_bloc > rep.msg_num[2])){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
    }*/
 if(verif_zone(disc_num,no_bloc,2)==-1){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
  }

  /*ecriture des champs nom*/
  for(i=0;i<4;i++){
    memcpy(bloc_rep+(i*32),(*b_rep)[i].nom,30);
  }

 /*ecriture des champs  numero*/
  for(i=0;i<4;i++){
    toLESHORT((*b_rep)[i].numero,leus);
    memcpy(bloc_rep+30+(i*32),leus,SSIZE);
  }

  //affblk(bloc_rep);//debug

  /*ecriture sur le disque*/
  /*if(ifs_name_dev(disc_num,&rep)==-1)return -1;
  disc_name=(char *)concat(rep.msg,".ifs");
  if((descr=open(disc_name,O_WRONLY))==-1)return -1;
  if(writeb(descr,bloc_rep,no_bloc)==-1)return -1;
  if(close(descr)==-1) return -1;*/
  if(cache_writeb(disc_num,no_bloc,bloc_rep)==-1) return-1;
  return 1;
}

//lecture d'un bloc de repertoire
int read_bloc_rep(USHORT disc_num,bloc_rep *b_rep,USHORT no_bloc){
  bloc bloc_rep;
  LESHORT leus;
  reponse rep;
  int i,j,descr;
  char *disc_name;

  /*verification de l'emplacement de lecture*/
  /*if(ifs_num_ino_data(disc_num,&rep)==-1) return -1;
  if((no_bloc<rep.msg_num[1])||(no_bloc > rep.msg_num[2])){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
    }*/

 if(verif_zone(disc_num,no_bloc,2)==-1){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
  }

  /*lecture sur le disque*/
  /*if(ifs_name_dev(disc_num,&rep)==-1)return -1;
  disc_name=(char *)concat(rep.msg,".ifs");
  if((descr=open(disc_name,O_RDONLY))==-1)return -1;
  if(readb(descr,bloc_rep,no_bloc)==-1)return -1;
  if(close(descr)==-1) return -1;*/
  if(cache_readb(disc_num,no_bloc,bloc_rep)==-1) return-1;

  //affblk(bloc_rep);//debug

  /*lecture des champs nom*/
  for(i=0;i<4;i++){
    memcpy((*b_rep)[i].nom,bloc_rep+(i*32),30);
  }

  /*lecture des champs numero*/
  for(i=0;i<4;i++){ 
    memcpy(leus,bloc_rep+30+(i*32),SSIZE);
    (*b_rep)[i].numero=toUS(leus);
  }

  return 1;
}


//ecriture d'un bloc libre

int write_free_bloc(USHORT disc_num,free_bloc *free_b,USHORT no_bloc){
  bloc free_bloc;
  LESHORT leus;
  reponse rep;
  int i,j,descr;
  char *disc_name;

  /*verification de l'emplacement d'ecriture*/
  /*if(ifs_num_ino_data(disc_num,&rep)==-1) return -1;
  if((no_bloc<rep.msg_num[1])||(no_bloc > rep.msg_num[2])){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
    }*/

 if(verif_zone(disc_num,no_bloc,2)==-1){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
  }

  /*ecriture du champ next_index*/
    toLESHORT(free_b->next_index,leus);
    memcpy(free_bloc,leus,SSIZE);

  /*ecriture du champ cpt*/
    toLESHORT(free_b->cpt,leus);
    memcpy(free_bloc+2,leus,SSIZE);

  /*ecriture du champs blocs*/
  for(i=0;i<62;i++){
    toLESHORT(free_b->blocs[i],leus);
    memcpy(free_bloc+4+(i*2),leus,SSIZE);
  }

  // affblk(free_bloc);//debug

  /*ecriture du bloc sur le disque*/
  /*if(ifs_name_dev(disc_num,&rep)==-1)return -1;
  disc_name=(char *)concat(rep.msg,".ifs");
  if((descr=open(disc_name,O_WRONLY))==-1)return -1;
  if(writeb(descr,free_bloc,no_bloc)==-1)return -1;
  if(close(descr)==-1) return -1;*/
  if(cache_writeb(disc_num,no_bloc,free_bloc)==-1) return-1;
  return 1;
}


/*lecture d'un bloc libre*/
int read_free_bloc(USHORT disc_num,free_bloc *free_b,USHORT no_bloc){
  int descr,i,j;
  char *disc_name;
  bloc free_bloc;
  LESHORT leus;
  reponse rep;

 /*verification de l'emplacement de lecture*/
  /*if(ifs_num_ino_data(disc_num,&rep)==-1) return -1;
  if((no_bloc<rep.msg_num[1])||(no_bloc > rep.msg_num[2])){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
    }*/

 if(verif_zone(disc_num,no_bloc,2)==-1){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
  }

  /*lecture sur le disque*/
  /*if(ifs_name_dev(disc_num,&rep)==-1)return -1;
  disc_name=(char *)concat(rep.msg,".ifs");
  if((descr=open(disc_name,O_RDONLY))==-1)return -1;
  if(readb(descr,free_bloc,no_bloc)==-1)return -1;
  if(close(descr)==-1) return -1;*/
  if(cache_readb(disc_num,no_bloc,free_bloc)==-1) return-1;

  /*lecture du champs next_index*/
    memcpy(leus,free_bloc,SSIZE);
    free_b->next_index=toUS(leus);

  /*lecture du champs cpt*/
    memcpy(leus,free_bloc+2,SSIZE);
    free_b->cpt=toUS(leus);

  /*lecture du champs blocs*/
  for(i=0;i<62;i++){
    memcpy(leus,free_bloc+4+(i*2),SSIZE);
    free_b->blocs[i]=toUS(leus);
  }

 
  return 1;
}

//ecriture d'un bloc de donnes

int write_bloc(USHORT disc_num,bloc b,USHORT no_bloc){
  reponse rep;
  int descr;
  char *disc_name;

  /*verification de l'emplacement d'ecriture*/
  /*if(ifs_num_ino_data(disc_num,&rep)==-1) return -1;
  if((no_bloc<rep.msg_num[1])||(no_bloc > rep.msg_num[2])){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
    }*/

 if(verif_zone(disc_num,no_bloc,2)==-1){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
  }

 //affblk(b);//debug

  /*ecriture du bloc sur le disque*/
  /*if(ifs_name_dev(disc_num,&rep)==-1)return -1;
  disc_name=(char *)concat(rep.msg,".ifs");
  if((descr=open(disc_name,O_WRONLY))==-1)return -1;
  if(writeb(descr,*b,no_bloc)==-1)return -1;
  if(close(descr)==-1) return -1;*/
  if(cache_writeb(disc_num,no_bloc,b)==-1) return-1;
  return 1;
}


/*lecture d'un bloc de donnes*/
int read_bloc(USHORT disc_num,bloc b,USHORT no_bloc){
  int descr;
  char *disc_name;
  reponse rep;

 /*verification de l'emplacement de lecture*/
  /*if(ifs_num_ino_data(disc_num,&rep)==-1) return -1;
  if((no_bloc<rep.msg_num[1])||(no_bloc > rep.msg_num[2])){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
    }*/
 if(verif_zone(disc_num,no_bloc,2)==-1){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
  }

  /*lecture sur le disque*/
  /*if(ifs_name_dev(disc_num,&rep)==-1)return -1;
  disc_name=(char *)concat(rep.msg,".ifs");
  if((descr=open(disc_name,O_RDONLY))==-1)return -1;
  if(readb(descr,*b,no_bloc)==-1)return -1;
  if(close(descr)==-1) return -1;*/
  if(cache_readb(disc_num,no_bloc,b)==-1) return-1;

  //affblk(b);
  return 1;
}


//ecriture d'un bloc de inode_map

int write_map_bloc(USHORT disc_num,bloc map_b,USHORT no_bloc){
  reponse rep;
  int descr;
  char *disc_name;

  /*verification de l'emplacement d'ecriture*/
  /*if(ifs_num_ino_data(disc_num,&rep)==-1) return -1;
  if((no_bloc<=1)||(no_bloc >= rep.msg_num[0])){//l'adresse du premier inode_map est 2 car l'addresse 1 est..
    ifs_err=BAD_BLOC_ALLOC;//...reserv au pointeur IFS_NULL
    return -1;
    }*/

 if(verif_zone(disc_num,no_bloc,0)==-1){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
  }


 // affblk(map_b);//debug

  /*ecriture du bloc sur le disque*/
  /*if(ifs_name_dev(disc_num,&rep)==-1)return -1;
  disc_name=(char *)concat(rep.msg,".ifs");
  if((descr=open(disc_name,O_WRONLY))==-1)return -1;
  if(writeb(descr,*map_b,no_bloc)==-1)return -1;
  if(close(descr)==-1) return -1;*/
  if(cache_writeb(disc_num,no_bloc,map_b)==-1) return-1;
  return 1;  
}


/*lecture d'un bloc de inode_map*/
int read_map_bloc(USHORT disc_num,bloc map_b,USHORT no_bloc){
  int descr;
  char *disc_name;
  reponse rep;

 /*verification de l'emplacement de lecture*/
  /*if(ifs_num_ino_data(disc_num,&rep)==-1) return -1;
  if((no_bloc<=1)||(no_bloc > rep.msg_num[0])){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
    }*/

 if(verif_zone(disc_num,no_bloc,0)==-1){
    ifs_err=BAD_BLOC_ALLOC;
    return -1;
  }

  /*lecture sur le disque*/
  /*if(ifs_name_dev(disc_num,&rep)==-1)return -1;
  disc_name=(char *)concat(rep.msg,".ifs");
  if((descr=open(disc_name,O_RDONLY))==-1)return -1;
  if(readb(descr,*map_b,no_bloc)==-1)return -1;
  if(close(descr)==-1) return -1;*/
  if(cache_readb(disc_num,no_bloc,map_b)==-1) return-1;

 
  return 1; 
}
