/****************************************************************
*Fichier cree par :                                             *
*                 Selma Abdelrahim                              *
*                 Farzana Chutkai                               *
*                 Denis Berthod                                 *
*Pour le projet du cours de systeme du premier semestre         *
*de l'anne 2003/2004 : Le systeme IFS                          *
*****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ifs_error.h"
#include "ifs_kernelio.h"
#include <errno.h>

void fatal_error(char* msg){
  errno=cause();
  perror(msg);
  exit(EXIT_FAILURE);
}

void ifs_fatal_error(char* msg){
  ifs_err = ifs_cause();
  errno=cause();
  if(ifs_err !=0){
    ifs_perror(msg);
  }else{
    perror(msg);
  }
  exit(EXIT_FAILURE);
}

char* concat(char*s,char*t){
  char *r;
 
  if((r = (char*)strdup(s)) == NULL){
    fprintf(stderr,"strdup\n");
    exit(EXIT_FAILURE);
  }
 
  if ((r=realloc(r,strlen(s) + strlen(t) +1)) == NULL){
    fprintf(stderr,"realloc\n");
    exit(EXIT_FAILURE);
  }
  return strncat(r,t,strlen(t));
}
 
char *concat_rep(char* s,char* t){
  return concat(s,concat("/",t));
}

char *ctoh(unsigned char c){
  char resultat[3];
  int poidsfaible,poidsfort;
  poidsfaible=c%16;
  poidsfort=c/16;
  switch(poidsfort){
  case 0:resultat[0]='0';break;
  case 1:resultat[0]='1';break;
  case 2:resultat[0]='2';break;
  case 3:resultat[0]='3';break;
  case 4:resultat[0]='4';break;
  case 5:resultat[0]='5';break;
  case 6:resultat[0]='6';break;
  case 7:resultat[0]='7';break;
  case 8:resultat[0]='8';break;
  case 9:resultat[0]='9';break;
  case 10:resultat[0]='A';break;
  case 11:resultat[0]='B';break;
  case 12:resultat[0]='C';break;
  case 13:resultat[0]='D';break;
  case 14:resultat[0]='E';break;
  case 15:resultat[0]='F';break;
  }
  switch(poidsfaible){
  case 0:resultat[1]='0';break;
  case 1:resultat[1]='1';break;
  case 2:resultat[1]='2';break;
  case 3:resultat[1]='3';break;
  case 4:resultat[1]='4';break;
  case 5:resultat[1]='5';break;
  case 6:resultat[1]='6';break;
  case 7:resultat[1]='7';break;
  case 8:resultat[1]='8';break;
  case 9:resultat[1]='9';break;
  case 10:resultat[1]='A';break;
  case 11:resultat[1]='B';break;
  case 12:resultat[1]='C';break;
  case 13:resultat[1]='D';break;
  case 14:resultat[1]='E';break;
  case 15:resultat[1]='F';break;
  }
  resultat[2]='\0';
  return (char*)strdup(resultat);
}

/*Coupe une reference en deux partie : une partie chemin du repertoiree t l'autre nom du fichier ou du dernier repertoire*/
void cutref(char *ref,char *finref,char *debref){
  char *debut, *fin;
  int cpt,cpt2;
  cpt=0;
  cpt2=0;
  debut=ref;
  while (*debut=='/') {debut++;cpt2++;}
  fin=debut;
  while(*fin != '\0'){
    if((*fin =='/') && ((*fin+1 != '\0')||(*fin+1 != '/'))){
      debut=fin+1;
      cpt2+=cpt+1;
      cpt=0;
    }
    if(*fin !='/') cpt++;
    fin++;
  }
  printf("la valeur de cpt2 est %d\n",cpt2);
  strncpy(finref,debut,cpt);
  finref[cpt]='\0';
  printf(" lafin de la reference est %s\n",finref);
  strncpy(debref,ref,cpt2);
  debref[cpt2]='\0';
  printf("le debut de la reference est %s\n",debref);
}

/*separe le nom du disc du nom du repertoire dans une reference le disqu est delimmite par les carateres :nom_du_disque:
 *dans le cas ou l'une des deux refrerence (disc_ref ou dir_ref n'existeraient pas elle contien '\0'
*/
void parse_discref(char *ref,char *disc_ref,char *dir_ref){
  char *curseur,*cur_disc;
  int cpt;

  /*si le premier caractre n'est pas ':' alors le disque n'est spcifie*/
  if(*ref != ':'){
    disc_ref[0]='\0';
    strcpy(dir_ref,ref);
    return ;
  }

  /*sinon, on parse*/
  curseur=ref;
  while(*curseur==':') curseur++;
  cur_disc=curseur;
  cpt=0;
  while((*curseur != ':') && (*curseur !='\0')){
    curseur ++;
    cpt++;
  }
  strncpy(disc_ref,cur_disc,cpt);
  disc_ref[cpt]='\0';
  while(*curseur == ':') curseur++;
  if(*curseur == '\0'){
    dir_ref[0]='\0';
  }else{
    strcpy(dir_ref,curseur);
  }
}
